#! /usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on January 25, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^mail\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
require 'config.pl';
require "$language.lib";
use Socket;

&parse_form;

if($FORM{'action'} eq "" || $FORM{'action'} eq "$TXT{'286'}" || $FORM{'action'} eq "$TXT{'287'}") {
	
	&check_pass;
	
	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[1]);
	@fields = split(/\&\&/,$MYINFO[1]);
	push(@fields,"remove link");
	
	if(! -e "$base_dir/messages") {
    	mkdir("$base_dir/messages",0777) || &admin_error("$TXT{'1'}: messages");
    }
    if(! -e "$base_dir/temp") {
    	mkdir("$base_dir/temp",0777) || &admin_error("$TXT{'1'}: temp");
    }
	
	if($FORM{'action'} eq "$TXT{'286'}") {
		if(! $FORM{'msg'}) {
			&admin_error("$TXT{'170'}");
		}
		open(MESSAGE,"$base_dir/messages/$FORM{'msg'}.save") || &admin_error("$TXT{'2'} $FORM{'msg'}.save");
		@MYMESSAGE = <MESSAGE>;
		close(MESSAGE);
		
		$mymessage = join("",@MYMESSAGE);
	}
	elsif($FORM{'action'} eq "$TXT{'287'}") {
		if(! $FORM{'msg'}) {
			&admin_error("$TXT{'171'}");
		}
		unlink("$base_dir/messages/$FORM{'msg'}.save") || &admin_error("$TXT{'162'} $FORM{'msg'}.save");
	}
	
	&admin_header($spellchecker);

	print qq!
	<SCRIPT LANGUAGE="Javascript">
	
	<\!------------
	
	function ViewFilter() {
		var selected = document.mailform.filters.selectedIndex;
		var filter = document.mailform.filters.options[selected].value;
		alert("Post Office will open a new window in order for you to view" +
		" the contents of the filter.  After you are finished viewing the filter" +
		" results, close the window and you will return to this screen.");
		var myloc = "mail.pl?action=view&name=$FORM{'name'}&filter=" + filter;
		var msgWindow=window.open(myloc,"ViewFilters","toolbar=no,location=no,directories=no,menubar=no,scrollbars=yes,width=600,height=400");
		//msgWindow.location = myloc;
	}
	
	function CreateFilter() {
		alert("Post Office will open a new window in order for you to create" +
		" a new filter.  After you are finished with creating the filter" +
		", close the window and you will return to this screen.");
		var msgWindow=window.open("mail.pl?action=new&name=$FORM{'name'}","ViewFilters","toolbar=no,location=no,directories=no,menubar=no,scrollbars=yes,width=600,height=400");
	}
	
	//------------>
	
	</SCRIPT>
	<H3>$TXT{'172'} $FORM{'name'}</H3>
	<B>
	$TXT{'173'} $FORM{'name'}.<P>
	</B>
	
	<FORM ACTION="mail.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	$TXT{'174'}<BR>
	<SELECT NAME="msg">
	<OPTION VALUE="">None</OPTION>
	!;
	
	opendir(BASE,"$base_dir/messages") || &admin_error("$TXT{'0'}");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.save$/) {
			print qq!
			<OPTION VALUE="$1">$1</OPTION>
			!;
		}
	}
	closedir(BASE);
	
	print qq!
	</SELECT><BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'286'}" NAME="action">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'287'}" NAME="action">
	</FORM><P>
	
	<B>$TXT{'175'}</B><BR>
	$TXT{'176'}
	<BR>
	<FORM ACTION="mail.pl" METHOD="POST" NAME="mailform">
	<SELECT NAME="filters">
	<OPTION VALUE="" SELECTED>None</OPTION>
	!;
	
	if(-e "$base_dir/filters") {
		opendir(BASE,"$base_dir/filters") || &admin_error("$TXT{'0'}");
		while($file = readdir(BASE)) {
			if($file =~ /^$FORM{'name'}-(.*)\.filter$/) {
				print qq!
				<OPTION VALUE="$1">$1</OPTION>
				!;
			}
		}
		closedir(BASE);
	}
	
	print qq!
	</SELECT><BR>
	<A HREF="javascript:ViewFilter()">$TXT{'177'}</A> | <A HREF="javascript:CreateFilter()">$TXT{'289'}</A>
	| <A HREF="javascript:document.location.reload()">$TXT{'178'}</A><P>
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="cmail">
	<INPUT TYPE="TEXT" NAME="from" SIZE=20 VALUE="$admin_name"> $TXT{'179'}<BR>
	<INPUT TYPE="TEXT" NAME="reply-to" SIZE=25 VALUE="$admin_email_address"> $TXT{'180'}<BR>
	<INPUT TYPE="TEXT" NAME="subject" SIZE=20> $TXT{'181'}<BR>
	<P>
	$TXT{'182'}<BR>
	<TEXTAREA NAME="comments" COLS=$col_width ROWS=$row_height WRAP=\"$word_wrap\">$mymessage</TEXTAREA><BR>
	!;
	
	if($spellchecker) {
		print qq!<INPUT TYPE= "BUTTON" VALUE= "Spell Check" onclick= "var f=document.forms[1]; doSpell ('en', f.comments, '$script_directory/sproxy.pl', true);">!;
	}
	
	print qq!
	<P>
	<INPUT TYPE="CHECKBOX" NAME="html" VALUE="on"> HTML Email<BR>
	$TXT{'183'}<P>
	
	<INPUT TYPE="CHECKBOX" NAME="save" VALUE="on"> $TXT{'184'}
	<INPUT TYPE="TEXT" NAME="save_name" SIZE=15><P>
	$TXT{'185'}<BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'186'}">
	</FORM><P>
	
	<B><FONT SIZE=3>$TXT{'187'}</FONT> &nbsp; </B>
	!;
	
	foreach $field (@fields) {
		print "&lt;&lt;$field&gt;&gt; &nbsp\;\n";
	}
	
	print qq!
	<BR>
	$TXT{'188'}<P>
	$TXT{'75'}
	!;
	&admin_footer;
	
}

elsif($FORM{'action'} eq "cmail") {
	
	if($FORM{'continue'} ne "yes") {
		open(MESSAGE,">$base_dir/temp/$FORM{'name'}.msg") || &admin_error("$TXT{'1'} $FORM{'name'}.msg");
		print MESSAGE "$FORM{'html'}\n";
		print MESSAGE "$FORM{'reply-to'}\n";
		print MESSAGE "$FORM{'from'}\n";
		print MESSAGE "$FORM{'subject'}\n";
		print MESSAGE "$FORM{'comments'}";
		close(MESSAGE);
	}
	
	if($FORM{'save'}) {
		if(! $FORM{'save_name'}) {
			&admin_error("$TXT{'189'}");
		}
		open(MESSAGE,">$base_dir/messages/$FORM{'save_name'}.save") || &admin_error("$TXT{'1'} $FORM{'save_name'}.save");
		print MESSAGE "$FORM{'comments'}";
		close(MESSAGE);
	}
	
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office Admin - Mailing</TITLE>
	</HEAD>
	
	<FRAMESET ROWS="200,*" BORDER=0 FRAMEBORDER=0 FRAMESPACING=0>
		<FRAME SRC="mail.pl?action=topframe" NAME="top" SCROLLING="NO">
		<FRAME SRC="mail.pl?action=mail&name=$FORM{'name'}&continue=$FORM{'continue'}&filters=$FORM{'filters'}"
		NAME="bottom" SCROLLING="YES">
	</FRAMESET>
	!;

}

elsif($FORM{'action'} eq "topframe") {
	
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office Admin</TITLE>
	</HEAD>
	<BODY>
	<CENTER>
	<TABLE BORDER=0 WIDTH=600>
	<TR><TD>
	<FONT FACE="Arial" SIZE=4>
	<BR><BR>
	<B>$TXT{'190'}</B>
	</FONT>
	</TD></TR>
	</TABLE>
	</CENTER>
	</BODY>
	</HTML>
	!;
}

elsif($FORM{'action'} eq "mail") {

	&check_pass;
	
	# Check to see if there is already a mailing session.
	if(-e "$base_dir/temp/$FORM{'name'}.mail" && $FORM{'continue'} ne "yes") {
		open(MAIL,"$base_dir/temp/$FORM{'name'}.mail") || &admin_error("$TXT{'2'}: $name.mail");
		@MYMAIL =<MAIL>;
		close(MAIL);
		
		chomp($MYMAIL[2]);
		$mynowtime = time;
		if($mynowtime - $MYMAIL[2] < $wait_time + 120) {
			&admin_error("$TXT{'301'}");
		}
	}
	
	# Check to see if this is a continuation.  If so, gather the required data.
	if($FORM{'continue'} eq "yes") {
		open(LINENUM,"$base_dir/temp/$FORM{'name'}.mail") || &admin_error("$TXT{'2'} $FORM{'name'}.mail");
		@MAIL =<LINENUM>;
		close(LINENUM);
		chomp($start_line = shift(@MAIL));
		chomp($total_mailed = shift(@MAIL));
		chomp($ltime = shift(@MAIL));
		chomp($FORM{'filters'} = shift(@MAIL));
	}
	else {
		$total_mailed = 0;
		$start_line = 0;
	}
	
	# Input the message data
	open(MESSAGE,"$base_dir/temp/$FORM{'name'}.msg") || &admin_error("$TXT{'2'} $FORM{'name'}.msg");
	@MYMSG =<MESSAGE>;
	close(MESSAGE);
	chomp($FORM{'html'} = shift(@MYMSG));
	chomp($FORM{'reply-to'} = shift(@MYMSG));
	chomp($FORM{'from'} = shift(@MYMSG));
	chomp($FORM{'subject'} = shift(@MYMSG));
	$FORM{'comments'} = join("",@MYMSG);
	
	# For qmail users
	$FORM{'comments'} =~ s/\015\012/\n/gs;
	$FORM{'comments'} =~ s/\015/\n/gs;
	$FORM{'comments'} =~ s/\n/\015\012/gs;
	
	unless($FORM{'name'} && $FORM{'from'} && $FORM{'reply-to'} && $FORM{'subject'} && $FORM{'comments'}) {
		&admin_error("$TXT{'191'}");	
	}
	if($FORM{'reply-to'} !~ /.*\@.*\..*/) {
		&admin_error("$TXT{'192'}");
	}
	
	$mailed = 0;
	$line_num = 0;
	$this_batch = 0;
	
	# Gather the list information
	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);

	chomp($MYINFO[1]);
	@fields = split(/\&\&/,$MYINFO[1]);

	# If they are using filters, extract the criteria
	if($FORM{'filters'}) {
		
		open(FILTER,"$base_dir/filters/$FORM{'name'}-$FORM{'filters'}.filter") || &admin_error("$TXT{'2'} $FORM{'name'}-$FORM{'filters'}.filter");
		chomp($criteria =<FILTER>);
		close(FILTER);
		
		@criteria = split(/\&/,$criteria);
		foreach $crit (@criteria) {
			($cname,$cvalue) = split(/\=/,$crit);
			$CRITERIA{$cname} = $cvalue;
		}
	}
	
	# Connect to the SMTP server if that is the specified method
	if($mail_type) {
		&smtp_connect;
	}
		
	push(@fields,"remove link");
	
	$begin_time = time();
	
	# Create a copy of the mailing database if there isn't already one
	if(! -e "$base_dir/temp/$FORM{'name'}.dat") {
		&file_lock("$FORM{'name'}");
		open(BAK,">$base_dir/temp/$FORM{'name'}.dat") || &admin_error("$TXT{'1'} $FORM{'name'}.dat");
		open(LIST,"$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'2'} $FORM{'name'}.dat");
		while($line =<LIST>) {
			print BAK "$line";
		}
		close(LIST);
		close(BAK);
		&file_unlock("$FORM{'name'}");
	}
	
	print "Content-Type: text/html\n\n";
	
	# Open the mailing list and begin mailing.
	open(LIST,"$base_dir/temp/$FORM{'name'}.dat") || &admin_error("$TXT{'2'} $FORM{'name'}.dat");
	MAILLOOP: while($line =<LIST>) {
	
		# Skip the entry until we are at the start line
		$line_num++;
		if($line_num <= $start_line) {
			next MAILLOOP;
		}
		
		@listfields = split(/\&\&/,$line);
		chomp($listfields[$#listfields]);
		
		# Check if the entry meets the criteria
		foreach $key (keys %CRITERIA) {
			if($key =~ /^[0-9]*$/ && $CRITERIA{$key} ne "") {
				if($listfields[$key] !~ /$CRITERIA{$key}/i) {
					next MAILLOOP;
				}
			}
		}
		
		# Increment batch count
		$this_batch++;
		
		# Personalize the email
		$message = $FORM{'comments'};
		$subject = $FORM{'subject'};
		
		$num_fields = $#fields;
		if($num_fields <= 1) {
			chomp($to = $listfields[0]);
			$myto = $to;
			$myto =~ s/\@/\%40/;
			$myname = &encode("$FORM{'name'}");
			$listfields[1] = "$script_directory/manager.pl?action=delete&email=$myto&group1=$myname";
		}
		else {
			$i = 0;
			foreach $field (@fields) {
				if($field eq "email") {
					chomp($to = $listfields[$i]);
					$myto = $to;
					$myto =~ s/\@/\%40/;
					$myname = &encode("$FORM{'name'}");
					push(@listfields,"$script_directory/manager.pl?action=delete&email=$myto&group1=$myname");
				}
				$i++;
			}
		}
		
		if(! &checksyntax($to)) {
			next MAILLOOP;
		}
		
		$i = 0;
		foreach $field (@fields) {
			$myfield = "<<$field>>";
			$message =~ s/$myfield/$listfields[$i]/g;
			$subject =~ s/$myfield/$listfields[$i]/g;
			$i++;
		}
		
		if(! $mail_type) {
			# Send the mail using sendmail
			&sendmail;
		}
		else {
			# Send mail using SMTP server
			$retry = 0;
			while(! &smtp_send && $retry <= $max_mail_try) {
				&smtp_send;
				$retry++;
			}
		}
		
		# Increment counters
		$mailed++;
		$total_mailed++;
		
		if($continue_when_interrupted || $batch) {
			open(LINENUM,">$base_dir/temp/$FORM{'name'}.mail") || &error("$TXT{'1'} $FORM{'name'}.mail");
			print LINENUM "$line_num\n";
			print LINENUM "$total_mailed\n";
			$mytime = time;
			print LINENUM "$mytime\n";
			print LINENUM "$FORM{'filters'}";
			close(LINENUM);
		}
		
		if($this_batch >= $batch && $batch) {
			
			if($mail_type) {
				&smtp_disconnect;
			}	

			$end_time = time();
			$total_time = int($end_time - $begin_time);
			
			print qq!
			<HTML>
			<HEAD>
			<TITLE>Post Office Admin</TITLE>
			<meta http-equiv="Refresh" content="$wait_time;URL=mail.pl?action=mail&continue=yes&name=$FORM{'name'}">
			</HEAD>
			<BODY>
			<CENTER>
			<TABLE WIDTH=600 BORDER=0>
			<TR><TD>
			<FONT FACE="Arial" SIZE=3>
			<CENTER>
			<B>Post Office has finished processing $batch users in $total_time seconds and is now mailing
			the next $batch users.</B><P>
			
			$mailed users have been mailed in this batch and a total of $total_mailed
			messages have been mailed so far.
			<P>
			!;
			
			if(! -e "$base_dir/regit.num") {
				print qq!
				Tired of waiting for your mailings to be completed?  Purchase
				Post Office Pro now and you won't have to\!<P>
				!;
			}
			
			if($errors) {
				print "<H3>Errors</H3> $errors\n";
			}
			
			print qq!
			</CENTER>
			</FONT>
			</TD></TR>
			</TABLE>
			</CENTER>
			</BODY>
			</HTML>
			!;
			close(LIST);
			exit;		
		}
		
	} # End loop

	close(LIST);
	
	if($mail_type) {
		&smtp_disconnect;
	}
	
	if($continue_when_interrupted  || $batch) {
		unlink("$base_dir/temp/$FORM{'name'}.mail");
	}
	unlink("$base_dir/temp/$FORM{'name'}.msg");
	unlink("$base_dir/temp/$FORM{'name'}.dat");
	
	$end_time = time();
	$total_time = int(($end_time - $begin_time) / 60);

	if(! -e "$base_dir/log.txt") {
		open(LOG,">$base_dir/log.txt") || &admin_error("Unable to create log.txt");
		print LOG "";
		close(LOG);
	}
	
	$date = &getdate($end_time);
	
	open(LOG,">>$base_dir/log.txt") || &admin_error("Can't open log.txt");
	print LOG "$total_mailed email messages sent for the list, $FORM{'name'}, on $date\n";
	close(LOG);
	
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office Admin</TITLE>
	</HEAD>
	<BODY>
	<CENTER>
	<TABLE WIDTH=600 BORDER=0>
	<TR><TD>
	<FONT FACE="Arial" SIZE=3>
	
	<B>Post Office has finished mass mailing your group. A total of $line_num email addresses has been processed and $total_mailed email message(s) mailed.</B><P>
	!;
	
	if($errors) {
		print "<H3>Errors</H3>$errors<P>\n";
	}
	
	print qq!
	<A TARGET="main" HREF="admin.pl?action=main&username=$FORM{'username'}&password=$FORM{'password'}">Click Here</A> to return to the Administration home page.
	
	</FONT>
	</TD></TR>
	</TABLE></CENTER>
	</BODY>
	</HTML>
	!;
}
elsif($FORM{'action'} eq "view") {

	open(FILTER,"$base_dir/filters/$FORM{'name'}-$FORM{'filter'}.filter") || &admin_error("Unable to open Post Office file: $FORM{'name'}-$FORM{'filter'}.filter");
	chomp($search =<FILTER>);
	close(FILTER);
	$search =~ s/\s/+/g;
	
	print "Location: $script_directory/search.pl?action=search&name=$FORM{'name'}&$search\n\n";
}
elsif($FORM{'action'} eq "new") {
	&admin_header;
	print qq!
	<H3>$TXT{'202'}</H3>
	$TXT{'203'}<P>
	
	<CENTER>
	<B><A HREF="search.pl?name=$FORM{'name'}">$TXT{'66'}</A></B>
	</CENTER>
	!;
	&admin_footer;
}
else {
	&admin_error("$TXT{'4'}");	
}

sub sendmail {
	open(MAIL,"|$mailprog -t -oi") || &admin_error("Can't open Mail program: $mailprog\n");	
	if($FORM{'html'} eq "on") {
		print MAIL "Content-Type: text/html\n";
	}
	print MAIL "To: $to\n";
	print MAIL "From: \"$FORM{'from'}\" <$FORM{'reply-to'}>\n";
	print MAIL "Subject: $subject\n\n";
	
	#print out the message
	print MAIL $message, "\n";
	close(MAIL);
}

sub smtp_send {
	
	print MAIL "RSET\015\012";
	$response = <MAIL>;
	return 0 if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>$mailed has been already mailed before connection was lost.");
	}

	print MAIL "MAIL FROM:<$FORM{'reply-to'}>\015\012";
	$response = <MAIL>;
	&mail_error("Invalid Sender: $response<BR>$mailed has been already mailed before connection was lost.","1") if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>$mailed has been already mailed before connection was lost.");
	}

	print MAIL "RCPT TO:<$to>\015\012";
	$response = <MAIL>;
	return 0 if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>$mailed has been already mailed before connection was lost.");
	}

	#Let the server know we're gonna start sending data
	print MAIL "DATA\015\012";
	$response = <MAIL>;
	return 0 if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response<BR>$mailed has been already mailed before connection was lost.");
	}
	
	if($FORM{'html'} eq "on") {
		print MAIL "Content-Type: text/html\r\n";
	}
	print MAIL "To: $to\r\n";
	print MAIL "From: \"$FORM{'from'}\" <$FORM{'reply-to'}>\r\n";
	print MAIL "Subject: $subject\r\n\r\n";
	
	#print out the message
	print MAIL $message, "\r\n.\r\n";
	
	$response = <MAIL>;
	return 0 if ! $response || $response =~ /^[45]/;
	if ($response =~ /^221/){
		close(MAIL); 
		&error("Server disconnected: $response");
	}
	
	return 1;
}