#!/usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on April 2, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#


BEGIN {
if($0 !~ /^search\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'config.pl';
require 'library.pl';
require "$language.lib";

&parse_form;
&check_pass;

if(! $FORM{'groupname'}) {
	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);
}
else {
	open(INFO,"$base_dir/$FORM{'groupname'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);
}

@fields = split(/\&\&/,$MYINFO[1]);

if($FORM{'action'} eq "") {
	
	&admin_header;
	print qq!
	<H3>$TXT{'45'}</H3>
	$TXT{'250'}<P>
	
	<FORM ACTION="search.pl" METHOD="GET">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="search">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	!;
	
	$i = 0;
	foreach $field (@fields) {
		print qq!<TR><TD>$field</TD><TD><INPUT TYPE="TEXT" SIZE=15 NAME="$i"><BR></TD></TR>\n!;
		$i++;
	}
	
	print qq!
	</TABLE>
	<P><INPUT TYPE="SUBMIT" VALUE="$TXT{'251'}">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "search") {
	
	&admin_header;
	
	$search = "";
	foreach $key (keys %FORM) {
		if($key =~ /^[0-9]*$/ && $FORM{$key} ne "") {
			$search .= "$key=$FORM{$key}&";
		}
	}
	chop($search);
	$search =~ s/\s/+/g;
	
	print qq!
	<SCRIPT LANGUAGE="Javascript">
	<\!-------
	
	function CheckAll() {
		for(var i = 0;i < document.dform.elements.length;i++) {
			document.dform.elements[i].checked = true;
		}
	}
	
	function UncheckAll() {
		for(var i = 0;i < document.dform.elements.length;i++) {
			document.dform.elements[i].checked = false;
		}
	}
	
	function DeleteConf() {
		return confirm("$TXT{'252'}");
	}
	
	function edit(myline) {
		var msgWindow=window.open("search.pl?action=edit&name=$FORM{'name'}&myline=" + myline,"A","toolbar=no,location=no,directories=no,menubar=no,scrollbars=yes,width=250,height=300")
	}
	
	//-------->
	</SCRIPT>
	
	<H3>Search Criteria</H3>
	<FORM ACTION="search.pl" METHOD="GET">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="search">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	!;
	
	$i = 0;
	foreach $field (@fields) {
		print qq!<TR><TD>$field</TD><TD><INPUT TYPE="TEXT" SIZE=15 NAME="$i" VALUE="$FORM{$i}"><BR></TD></TR>\n!;
		$i++;
	}
	
	print qq!
	</TABLE><BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'272'}"><P>
	</FORM>
	<HR SIZE=1 WIDTH="95%">
	<TABLE BORDER=0 WIDTH="100%">
	<TR><TD>
	<H3>Search/Filter Results</H3>
	</TD><TD ALIGN="CENTER">
	<B><A HREF="#filters">$TXT{'253'}</A></B>
	</TD></TR>
	</TABLE>
	<FORM ACTION="search.pl" METHOD="POST" NAME="dform" onSubmit="return DeleteConf()">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="delete">
	
	<TABLE BGCOLOR="FFFFFF" BORDER=0 CELLSPACING=2 CELLPADDING=2>
	<TR BGCOLOR="FFDDDD"><TD><B>#</B></TD>
	!;
	
	foreach $field (@fields) {
		print "<TD><B>$field</B></TD>\n";
	}
	
	print "<TD><B>Delete?</B></TD><TD><B>Edit?</B></TD></TR>\n";
	$found = 0;
	if(! $FORM{'x'}) {
		$FORM{'x'} = 0;
	}
	$FORM{'y'} = $FORM{'x'} + 100;
	
	$start_time = time;
	
	open(LIST,"$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'2'} $FORM{'name'}.dat");
	while($line =<LIST>) {
		$next = 0;
		#$search = "";
		chomp($line);
		@listfields = split(/\&\&/,$line);
		foreach $key (keys %FORM) {
			if($key =~ /^[0-9]*$/ && $FORM{$key} ne "") {
				#$search .= "$key=$FORM{$key}&";
				if($listfields[$key] !~ /$FORM{$key}/i) {
					$next = 1;
					last;
				}
			}
		}
		#chop($search);
		
		$myline = $line;
		
		if(! $next) {
			
			$found++;
			
			if($found > $FORM{'x'} && $found <= $FORM{'y'}) {
				print "<TR BGCOLOR=\"DDDDDD\"><TD>$found</TD>\n";
				$i = 0;
				foreach $field (@fields) {
					print "<TD>$listfields[$i]</TD>\n";
					$i++;
				}
				# Change quotes into something else
				$myline =~ s/"/\[q\]/g;
				$myline2 = $myline;
				
				$myline2 =~ s/'/\%27/g;
				$myline2 =~ s/\[q\]/\%22/g;
				$myline2 =~ s/\&\&/\|\|/g;
				$myline2 =~ s/\s/+/g;
				
				print "<TD><INPUT TYPE=\"CHECKBOX\" NAME=\"$myline\" VALUE=\"1\"></TD><TD><A HREF=\"javascript: edit('$myline2')\">Edit</A></TD>\n";
				print "</TR>\n";
			}
		}
	}
	close(LIST);
	$end_time = time;
	$total_time = $end_time - $start_time;
	
	$colspan = $#fields + 3;
	
	$search =~ s/\"/\%22/g;
	
	if(! $found) {
		print "<TR BGCOLOR=\"DDDDDD\"><TD COLSPAN=$colspan>$TXT{'254'}</TD></TR>\n";
	}
	else {
		$colspan -= 1;
		print "<TR BGCOLOR=\"DDDDDD\"><TD COLSPAN=$colspan><B><FONT FACE=\"Arial\">$TXT{'255'} $found results $TXT{'256'} $total_time s.\n";
		print "</FONT></B></TD><TD COLSPAN=2><A HREF=\"javascript: CheckAll()\">$TXT{'257'}</A><BR><A HREF=\"javascript: UncheckAll()\">$TXT{'258'}</A></TD></TR>\n";
		$colspan += 1;
		print "<TR><TD COLSPAN=$colspan><FONT FACE=\"Arial\"><B>$TXT{'259'}</B> &nbsp;\n";
		$i = 1;
		if($FORM{'x'} > 0) {
			print "<A HREF=\"search.pl?$search&x=",$FORM{'x'} - 100,"&name=$FORM{'name'}&action=search\">$TXT{'260'}</A> |\n";
			$current = 0;
			while($current < $FORM{'x'}) {
				print qq!<A HREF="search.pl?$search&x=$current&name=$FORM{'name'}&action=search">$i</A> |\n!;
				$current += 100;
				$i += 1;
			}
		}
		
		print "$i |\n";
		$i += 1;
		
		if($found > $FORM{'y'}) {
			$current = $FORM{'y'};
			while($current < $found) {
				print qq!<A HREF="search.pl?$search&x=$current&name=$FORM{'name'}&action=search">$i</A> |\n!;
				$current += 100;
				$i += 1;
			}
			print qq!<A HREF="search.pl?$search&x=$FORM{'y'}&name=$FORM{'name'}&action=search">$TXT{'261'}</A>\n!;
		}
	}
	print "</TD></TR>\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"search\" VALUE=\"$search\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"name\" VALUE=\"$FORM{'name'}\">\n";
	print "<TR BGCOLOR=\"FFFFFF\"><TD COLSPAN=$colspan><CENTER><FONT FACE=\"Arial\"><INPUT TYPE=\"SUBMIT\" VALUE=\"$TXT{'275'}\"></FONT><BR><FONT FACE=\"Arial\" SIZE=2>$TXT{'262'}</FONT></TD></TR>\n";
	print "</TABLE></FORM><P><BR><A NAME=\"filters\"><H3>$TXT{'274'}</H3></A>\n";
	
	print qq!
	<FORM ACTION="search.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="save">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	!;
	
	foreach $key (keys %FORM) {
		if($key =~ /^[0-9]*$/ && $FORM{$key} ne "") {
			print qq!<INPUT TYPE="HIDDEN" NAME="$key" VALUE="$FORM{$key}">!;
		}
	}
	
	print qq!
	<FONT FACE="Arial" SIZE=2>
	$TXT{'263'}<P>
	</FONT><FONT FACE="Arial" SIZE=2>
	$TXT{'273'} <INPUT TYPE="TEXT" NAME="filtername" SIZE=15><BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'264'}">
	</FONT>
	!;
	
	print "<P><A HREF=\"search.pl?name=$FORM{'name'}\">$TXT{'265'}</A><BR>\n";
	print "$TXT{'75'}\n";
	&admin_footer;
}

elsif($FORM{'action'} eq "delete") {

	&file_lock("$FORM{'name'}");
	
	$num_deleted = 0;
	
	$enum = 0;
	@info_fields = split(/\&\&/,$MYINFO[1]);
	foreach $ifield (@info_fields) {
		if($ifield eq "email") {
			last;
		}
		$enum += 1;
	}
	
	open(LIST,"$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'1'} $FORM{'name'}.dat");
	open(TMP,">$base_dir/$FORM{'name'}.dat.tmp") || &admin_error("$TXT{'1'} $FORM{'name'}.dat.tmp");
	MAIN: while($line =<LIST>) {
		chomp($line);
		foreach $key (keys %FORM) {
			if($key eq "action" || $key eq "name" || $key eq "search") {
				next;
			}
			#if($line =~ /$key/i || $key =~ /$line/i) {
			$key =~ s/\[q\]/"/g;
			if($line eq "$key") {
				if($log_opt_out) {
    				if(! -e "$base_dir/$FORM{$field}.out") {
    					open(OPTOUT,">$base_dir/$FORM{$field}.out") || &error("$TXT{'1'} $FORM{$field}.out");
    					print OPTOUT "";
    					close(OPTOUT);
    				}
					@dfields = split(/\&\&/,$line);
					chomp($dfields[$enum]);
					open(OUT,">>$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'1'} $FORM{'name'}.out");
					print OUT "$dfields[$enum]\n";
					close(OUT);
				}
				$num_deleted += 1;
				next MAIN;
			}
		}
		print TMP "$line\n";
	}
	close(LIST);
	close(TMP);
	unlink("$base_dir/$FORM{'name'}.dat");
	rename("$base_dir/$FORM{'name'}.dat.tmp","$base_dir/$FORM{'name'}.dat");
	
	$MYINFO[0] -= $num_deleted;
	
	open(INFO, ">$base_dir/$FORM{'name'}.info") || &error("$TXT{'1'} $base_dir/$FORM{'name'}.info");
	print INFO "$MYINFO[0]\n";
	print INFO "$MYINFO[1]";
	close(INFO);
	
	&file_unlock("$FORM{'name'}");
	
	&admin_header;
	
	$TXT{'267'} =~ s/<<num_deleted>>/$num_deleted/g;
	
	print qq!
	<H3>$TXT{'266'}/H3>
	$TXT{'267'}<P>
	
	<A HREF="search.pl?action=search&name=$FORM{'name'}&$FORM{'search'}">$TXT{'268'}</A><BR>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "save") {

	&admin_error("$TXT{'269'}") unless $FORM{'filtername'};
	$FORM{'filtername'} =~ s/\s/\_/g;
	
	if(! -e "$base_dir/filters") {
		mkdir("$base_dir/filters",0777) || &admin_error("$TXT{'270'}");
	}
	
	$search = "";
	open(FILTER,">$base_dir/filters/$FORM{'name'}-$FORM{'filtername'}.filter") || &admin_error("$TXT{'1'} $FORM{'name'}-$FORM{'filtername'}.filter");
	foreach $key (keys %FORM) {
		if($key =~ /^[0-9]*$/ && $FORM{$key} ne "") {
			$search .= "$key=$FORM{$key}&";
		}
	}
	chop($search);
	print FILTER "$search";
	close(FILTER);
	
	&admin_header;
	print qq!
	<H3>$TXT{'271'}</H3><P><BR>
	
	<A HREF="search.pl?action=search&name=$FORM{'name'}&$FORM{'search'}">$TXT{'268'}</A><BR>
	$TXT{'75'}
	!;
	&admin_footer;
	
}
elsif($FORM{'action'} eq "edit") {

	#$FORM{'myline'} =~ s/\[sq\]/'/g;
	$myline = $FORM{'myline'};
	$myline =~ s/"/\[q\]/g;
	#$myline =~ s/\|\|/\&\&/g;

	@line_fields = split(/\|\|/,$myline);
	print "Content-Type: text/html\n\n";

	$i = 0;
	print qq!
	<FONT FACE="Arial" SIZE=2>
	Use the form below to make your changes.  After
	you are finished, press the save changes button.
	<P>
	<FORM ACTION="search.pl" METHOD="POST">
	
	<INPUT TYPE="HIDDEN" NAME="myline" VALUE="$myline">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="save edit">
	<INPUT TYPE="HIDDEN" NAME="groupname" VALUE="$FORM{'name'}">
	
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	!;
	foreach $field (@fields) {
		print qq!<TR><TD>$field</TD><TD><INPUT TYPE="TEXT" STYLE="font-family: Arial;font-size: 8pt" SIZE=20 NAME="$field" VALUE="$line_fields[$i]"></TD></TR>!;
		$i++;
	}
	print qq!
	</TABLE><BR>
	<INPUT TYPE="SUBMIT" VALUE="Save Changes">
	<INPUT TYPE="BUTTON" VALUE="Cancel" onClick="window.close()">
	</FORM></FONT>
	!;
}
elsif($FORM{'action'} eq "save edit") {

	&file_lock("$FORM{'groupname'}");
	
	$FORM{'myline'} =~ s/\|\|/\&\&/g;
	$FORM{'myline'} =~ s/\[q\]/"/g;
	
	$entry = "";
	print "Content-Type: text/html\n\n";
	open(LIST,"$base_dir/$FORM{'groupname'}.dat") || &admin_error("$TXT{'1'} $FORM{'groupname'}.dat");
	open(TMP,">$base_dir/$FORM{'groupname'}.dat.tmp") || &admin_error("$TXT{'1'} $FORM{'groupname'}.dat.tmp");
	MAIN: while($line =<LIST>) {
		chomp($line);

		#if($line =~ /$key/i || $key =~ /$line/i) {
		#print "$line<BR>$FORM{'myline'}<P>\n";
		if($line eq "$FORM{'myline'}") {
			foreach $field (@fields) {
				$FORM{$field} =~ s/\[q\]/"/g;
				$entry .= "$FORM{$field}&&";
			}
			chop($entry);
			chop($entry);
			print TMP "$entry\n";
			next MAIN;
		}

		print TMP "$line\n";
	}
	close(LIST);
	close(TMP);
	unlink("$base_dir/$FORM{'groupname'}.dat");
	rename("$base_dir/$FORM{'groupname'}.dat.tmp","$base_dir/$FORM{'groupname'}.dat");
	
	&file_unlock("$FORM{'groupname'}");
	

	print qq!
	<HTML>
	<HEAD>
	<TITLE>Changes Saved</TITLE>
	</HEAD>
	<SCRIPT LANGUAGE="Javascript">
	function done() {
		window.opener.location.reload();
		window.close();
	}
	</SCRIPT>
	<BODY onLoad="done()">
	</BODY>
	</HTML>
	!;
}

else {
	&admin_error("$TXT{'4'}");
}