#!/usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on April 2, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^admin\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
require 'config.pl';
require "$language.lib";

&parse_form;

$reg = &begin_admin;

if($FORM{'action'} eq "") {
	print "Content-Type: text/html\n\n";
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office Admin</TITLE>
	</HEAD>
	<FRAMESET COLS="150,*" FRAMEBORDER=0 FRAMESPACING=0 BORDER=0>
	<FRAME SCROLLING="NO" SRC="admin.pl?action=menu" NAME="menu">
	<FRAME SCROLLING="YES" SRC="admin.pl?action=main" NAME="main">
	</FRAMESET>
	</HTML>
	!;
}

elsif($FORM{'action'} eq "menu") {

	print "Content-Type: text/html\n\n";
	
	print qq!
	<HTML>
	<HEAD>
	<TITLE>Post Office Menu</TITLE>
	<BODY BGCOLOR="#FFDDDD" TEXT="#000000" LINK="#FF0000" ALINK="#FF0000" VLINK="BB0000">
	<FONT FACE="Arial" SIZE=2>
	<CENTER><H3>Post Office Pro $version</H3>
	</CENTER><B>
	<A HREF="admin.pl?action=main" TARGET="main">$TXT{'21'}</A><BR>
	<A HREF="admin.pl?action=settings" TARGET="main">$TXT{'22'}</A><BR>
	<A HREF="formwizard.pl" TARGET="main">$TXT{'23'}</A><BR>
	<A HREF="admin.pl?action=import" TARGET="main">$TXT{'24'}<BR>
	<A HREF="admin.pl?action=viewlog" TARGET="main">$TXT{'25'}</A><BR><BR>
	<A HREF="http://www.cgiparadise.com/news.html" TARGET="main">$TXT{'26'}</A><BR>
	<A HREF="http://www.cgiparadise.com/postoffice/doc4" TARGET="main">$TXT{'27'}</A><BR>
	<A HREF="http://www.cgiparadise.com/forum" TARGET="_new">$TXT{'28'}</A><BR><BR>
	<A HREF="admin.pl?action=logout" TARGET="main">$TXT{'29'}</A><BR><BR>
	!;
	
	if(! $regnumber) {
		print qq!
		<A HREF="admin.pl?action=registration" TARGET="main">$TXT{'30'}</A><BR>
		<A HREF="http://www.cgiparadise.com/purchase.html?p" TARGET="_new">$TXT{'31'}</A><BR>
		!;
	}
	
	if(! $reg && ! $regnumber) {
		print qq!
		<SCRIPT LANGUAGE="Javascript">
		
		alert("It has been 30 days since you started using Post Office.  In order to " +
		"continue using Post Office legally you must purchase a license from our web site.  " +
		"You can also follow the purchase link in the control panel to purchase a license.  " +
		"Thank you.");
		
		</SCRIPT>
		!;
	}
	
	print qq!
	</B></FONT>
	</BODY>
	!;
	
}

elsif($FORM{'action'} eq "login") {
	# Output the login page.	
	&admin_header;
	
	print qq!
	$TXT{'32'}<P>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
	<INPUT TYPE="TEXT" SIZE=15 NAME="username"> $TXT{'33'}<BR>
	<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> $TXT{'34'}<BR><BR>
	<INPUT TYPE="SUBMIT" VALUE="Continue">
	</FORM>
	!;
	
	&admin_footer;
}

elsif($FORM{'action'} eq "main") {
	# Output the main page.
	&check_pass;
	
	opendir(LISTS, "$base_dir") || &admin_error("$TXT{'0'}");
	
	&admin_header;
	
	
	print qq!
	$TXT{'35'}
	$TXT{'36'}
	
	<H3>$TXT{'37'}</H3>
	$TXT{'38'}
	$TXT{'39'}
	<TABLE CELLSPACING=0 CELLPADDING=4 BORDER=0 BGCOLOR="FFFFFF">
	<TR BGCOLOR="FF9999"><TD>
	<FONT COLOR="FFFFFF" FACE="Arial" SIZE=3><B><NOBR>$TXT{'40'}</NOBR></FONT></B></TD>
	<TD><FONT COLOR="FFFFFF" FACE="Arial" SIZE=3><B><NOBR>$TXT{'41'}</NOBR></B></FONT></TD>
	<TD><FONT COLOR="FFFFFF" FACE="Arial" SIZE=3><CENTER><B>$TXT{'42'}</B></CENTER></FONT></TD></TR>
	!;
	@mydir = readdir(LISTS);
	foreach $file (sort @mydir) {
	#while($file = readdir(LISTS)) {
		if($file =~ /^(.*)\.info$/) {
			$name = $1;
			open(LISTFILE,"$base_dir/$file") || &error("$TXT{'2'} $file");
			@MYFILE =<LISTFILE>;
			close(LISTFILE);
			chomp($count = $MYFILE[0]);
			$MYFILE[1] =~ s/\&\&/\,\ /g;
			#print "<TR BGCOLOR=\"FFFFFF\"><TD COLSPAN=3><IMG SRC=\"blah.gif\" BORDER=0 WIDTH=1 HEIGHT=2></TD></TR>\n";
			print "<TR BGCOLOR=\"FFDDDD\"><TD>$name</TD><TD>$count</TD><TD><CENTER>\n";
			print "<A HREF=\"mail.pl?name=$name\"><FONT COLOR=\"FF0000\">$TXT{'43'}</FONT></A> |\n";
			print "<A HREF=\"admin.pl?action=autoresponders&name=$name\"><FONT COLOR=\"FF0000\">$TXT{'44'}</FONT></A> |\n";
			print "<A HREF=\"search.pl?name=$name\"><FONT COLOR=\"FF0000\">$TXT{'45'}</FONT></A> |\n";
			print "<A HREF=\"admin.pl?action=add&groupname=$name\"><FONT COLOR=\"FF0000\">$TXT{'46'}</FONT></A> |\n";
			print "<A HREF=\"export.pl?name=$name\"><FONT COLOR=\"FF0000\">$TXT{'47'}</FONT></A> |\n";
			if($backup && -e "$base_dir/backup/$name.dat") {
				print "<A HREF=\"admin.pl?action=backup&name=$name\"><FONT COLOR=\"FF0000\"><NOBR>$TXT{'48'}</NOBR></FONT></A> |\n";
			}
			if(-e "$base_dir/temp/$name.mail" && $continue_when_interrupted) {
				open(MAIL,"$base_dir/temp/$name.mail") || &admin_error("$TXT{'2'}: $name.mail");
				@MYMAIL =<MAIL>;
				close(MAIL);
				chomp($MYMAIL[2]);
				$mynowtime = time;
				if($mynowtime - $MYMAIL[2] > $wait_time + 120) {
					print "<A HREF=\"mail.pl?action=cmail&continue=yes&name=$name\"><FONT COLOR=\"FF0000\"><NOBR>$TXT{'49'}</NOBR></FONT></A> |\n";
					print qq!
					<SCRIPT LANGUAGE="Javascript">
					alert("$TXT{'300'}");
					</SCRIPT>
					!;
				}
			}
			
			if($log_opt_out) {
				print "<A HREF=\"optout.pl?name=$name\"><FONT COLOR=\"FF0000\">$TXT{'303'}</FONT></A> |\n";
			}
			
			print "<A HREF=\"admin.pl?action=tidyup&name=$name\"><FONT COLOR=\"FF0000\">$TXT{'299'}</FONT></A> |\n";
			print "<A HREF=\"admin.pl?action=delete&name=$name\"><FONT COLOR=\"FF0000\">$TXT{'50'}</FONT></A>\n";
			print "</CENTER></TD></TR><TR BGCOLOR=\"CCCCCC\"><TD COLSPAN=3>\n";
			print "<B>$TXT{'51'}</B> $MYFILE[1]</TD></TR>\n";
		
		}
	}
	closedir(LISTS);
	print qq!
	</TABLE><P><BR>
	<IMG SRC="http://www.web-consult.com/cgi-bin/sys2/postoffice.cgi?$regnumber&$admin_email_address&$script_directory" BORDER=0 WIDTH=1 HEIGHT=1><BR>
	<H3>$TXT{'52'}</H3>
	$TXT{'53'}<P>
	
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="create">
	$TXT{'54'}
	<INPUT TYPE="TEXT" SIZE=15 NAME="name"><P>
	<B>$TXT{'55'}</B><BR>
	$TXT{'56'}<P>
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=4>
	<TR><TD>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field1" VALUE="email"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field2"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field3"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field4"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field5"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field6"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field7"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field8"><BR>
	</TD><TD>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field9"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field10"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field11"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field12"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field13"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field14"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field15"><BR>
	<INPUT TYPE="TEXT" SIZE=15 NAME="field16"><BR>
	</TD><TD VALIGN="TOP">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'52'}"><P>
	
	<INPUT TYPE="CHECKBOX" NAME="ip" VALUE="1"> Enable IP logging<P>
	
	<INPUT TYPE="CHECKBOX" NAME="date" VALUE="1"> Enable Date logging<BR>
	
	</TD></TR>
	</TABLE>
	</FORM><BR>
	!;
	&admin_footer;
}
elsif($FORM{'action'} eq "import") {
	
	&check_pass;
	@GROUPS = ();
	opendir(BASE,"$base_dir") || &admin_error("$TXT{'2'} $base_dir");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			push(@GROUPS,"$1");
		}
	}
	closedir(BASE);
	
	&admin_header;
	print qq!
	<H3>$TXT{'57'}</H3>
	$TXT{'58'}<P>

	<FORM ACTION="import.pl" METHOD="POST" enctype="multipart/form-data">
	$TXT{'59'}<BR>
	<INPUT TYPE="FILE" NAME="file"><P>
	
	$TXT{'60'}<BR>
	<SELECT NAME="name">
	<OPTION VALUE="">None</OPTION>
	!;
	
	foreach $group (@GROUPS) {
		print "<OPTION>$group</OPTION>\n";
	}
	
	print qq!
	</SELECT><P>
	
	<INPUT TYPE="CHECKBOX" NAME="new" VALUE="1"> $TXT{'61'}
	<INPUT TYPE="TEXT" NAME="new_name" SIZE=15><P>
	
	$TXT{'62'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="delimiter"><P>
	
	$TXT{'63'}<BR>
	<INPUT TYPE="RADIO" NAME="quote" VALUE="single"> $TXT{'64'}
	<INPUT TYPE="RADIO" NAME="quote" VALUE="double"> $TXT{'65'}
	<INPUT TYPE="RADIO" NAME="quote" VALUE="" CHECKED="CHECKED"> $TXT{'67'}<P>
	
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
	</FORM>
	!;
	&admin_footer;
}
elsif($FORM{'action'} eq "create") {
	
	# Creating New Lists
	&check_pass;
	$FORM{'name'} =~ s/\ /\_/g;
	
	&admin_error("$TXT{'68'}") unless $FORM{'name'};
	
	if($FORM{'name'} =~ /\W/) {
		&admin_error("$TXT{'69'}");
	}
	
	if(-e "$base_dir/$FORM{'name'}.info") {
		$TXT{'70'} =~ s/<<name>>/$FORM{'name'}/g;
		&admin_error("$TXT{'70'}");
	}
	
	$f_ok = 0;
	for($i=1;$i<=16;$i++) {	
		$field = "field$i";
		if($FORM{$field} eq "groupname" || $FORM{$field} =~ /^group\d+$/i
			|| $FORM{$field} eq "redirect" || $FORM{$field} eq "subscribe_redirect"
			|| $FORM{$field} eq "unsubscribe_redirect" || $FORM{$field} eq "verify_redirect"
			|| $FORM{$field} eq "action" || $FORM{$field} eq "proceed" || $FORM{$field} eq "date"
			|| $FORM{$field} eq "ip") {
			
			&admin_error("$TXT{'71'}<P><UL>
			groupname<BR>
			redirect<BR>
			subscribe_redirect<BR>
			unsubscribe_redirect<BR>
			verify_redirect<BR>
			action<BR>
			group1, group2, group3, .... etc.<BR>
			</UL><P>");
					
		}
		if($FORM{$field} eq "email") {
			$f_ok = 1;
		}
	}
	if(! $f_ok) {
		&admin_error("$TXT{'293'}");
	}
	
	open(LIST,">$base_dir/$FORM{'name'}.info") || &error("$TXT{'1'} $FORM{'name'}.info");
	print LIST "0\n";
	$format = "";
	for($i=1;$i<=16;$i++) {
		
		$field = "field$i";
		
		if($FORM{$field} ne "") {
			$format .= "$FORM{$field}&&";
		}
	}
	chop($format);
	chop($format);
	
	if($FORM{'date'}) {
		$format .= "&&date";
	}
	if($FORM{'ip'}) {
		$format .= "&&ip";
	}
	
	print LIST $format;
	close(LIST);
	
	open(DAT,">$base_dir/$FORM{'name'}.dat") || &error("$TXT{'1'} $FORM{'name'}.dat");
	print DAT "";
	close(DAT);

	if(! -e "$base_dir/autoresponders") {
		mkdir("$base_dir/autoresponders",0777) || &admin_error("$TXT{'1'} autoresponders");
	}
	
	if($verify_new_users && ! -e "$base_dir/autoresponders/all.verify") {
		open(MESSAGE,">$base_dir/autoresponders/all.verify") || &admin_error("$TXT{'1'} $FORM{'name'}.info");
		print MESSAGE "$admin_name\n";
		print MESSAGE "$admin_email_address\n";
		print MESSAGE "Verify your email\n\n";
		print MESSAGE "Thank you for signing up for our mailing list.  To finalize your\n";
		print MESSAGE "addition to our mailing list please follow the link below.\n";
		print MESSAGE "Thank you!\n\n";

		print MESSAGE "<<verify link>>\n\n";

		print MESSAGE "This mailing list is powered by: Post Office Pro $version\n";
		print MESSAGE "http://www.cgiparadise.com";
		close(MESSAGE);
	}
	
	&admin_header;
	print qq!
	<B>$TXT{'72'}</B><P>
	$TXT{'73'}<P>
	!;
	
	@fields = split(/\&\&/,$format);
	print "&lt;FORM ACTION=\"URL to manager.pl\" METHOD=\"POST\"&gt;<BR>\n";
	print "&lt;INPUT TYPE=\"HIDDEN\" NAME=\"group1\" VALUE=\"$FORM{'name'}\"&gt;\n";
	foreach $field (@fields) {
		if($field eq "date" || $field eq "ip") {
			next;
		}
		print "$field &lt;INPUT TYPE=\"TEXT\" NAME=\"$field\" SIZE=15&gt;&lt;BR&gt;<BR>\n";
	}
	print "&lt;INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"add\" CHECKED=\"CHECKED\"&gt; $TXT{'76'}&lt;BR&gt;<BR>\n";
	print "&lt;INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"remove\"&gt; $TXT{'77'}&lt;BR&gt;<BR>\n";
	print "&lt;INPUT TYPE=\"SUBMIT\" VALUE=\"Submit\"&gt;<BR>\n";
	print "&lt;/FORM&gt;<P>\n";
	
	print "$TXT{'78'}<P><FORM ACTION=\"manager.pl\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"group1\" VALUE=\"$FORM{'name'}\">\n";
	foreach $field (@fields) {
		if($field eq "date" || $field eq "ip") {
			next;
		}
		print "$field <INPUT TYPE=\"TEXT\" NAME=\"$field\" SIZE=15><BR>\n";
	}
	print "<INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"add\" CHECKED=\"CHECKED\"> $TXT{'76'}\n";
	print "<INPUT TYPE=\"RADIO\" NAME=\"action\" VALUE=\"remove\"> $TXT{'77'}<BR>\n";
	print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Submit\"></FORM>\n";
	print qq!
	<P>$TXT{'74'}<P>
	
	<B>$TXT{'75'}</B>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "autoresponders") {
	# Output the autoresponder settings page
	&check_pass;
	
	if(! -e "$base_dir/autoresponders") {
		mkdir("$base_dir/autoresponders",0777) || &admin_error("$TXT{'1'} autoresponders");
	}
	
	open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
	@MYINFO =<INFO>;
	close(INFO);
	
	chomp($MYINFO[1]);
	@fields = split(/\&\&/,$MYINFO[1]);
	$mytags = join("&gt;&gt;, &lt;&lt;", @fields);
	$mytags .= "&gt;&gt;";
	$mytags = "&lt;&lt;$mytags";
	
	&admin_header($spellchecker);
	print qq!
	<H3>$TXT{'79'} $FORM{'name'}</H3>
	$TXT{'80'}<P><UL>
	<LI> <A HREF="#add">$TXT{'81'}</A> </LI><BR>
	<LI> <A HREF="#remove">$TXT{'82'}</A> </LI><BR>
	<LI> <A HREF="#notify">$TXT{'83'}</A> </LI><BR>
	<LI> <A HREF="#verify">$TXT{'84'}</A> $TXT{'85'}</LI><BR>
	</UL><P><BR>
	
	<A NAME="add"><H3>$TXT{'81'}</H3></A>
	$TXT{'86'}
	$TXT{'87'}<P>
	
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="type" VALUE="add">
	!;
	
	open(MESSAGEFILE, "$base_dir/autoresponders/$FORM{'name'}.add");
	@MESSAGE =<MESSAGEFILE>;
	close(MESSAGEFILE);
	chomp($from = shift(@MESSAGE));
	chomp($reply_to = shift(@MESSAGE));
	chomp($subject = shift(@MESSAGE));
	chomp($html = shift(@MESSAGE));
	$message = join("",@MESSAGE);
	
	if(! $from) {
		$from = $admin_name;
	}
	
	if(! $reply_to) {
		$reply_to = $admin_email_address;
	}
	
	if($html eq "on") {
		$html_on = "CHECKED=\"CHECKED\"";
	}
	else {
		$html_on = "";
	}
	
	print "<INPUT TYPE=\"TEXT\" NAME=\"from\" VALUE=\"$from\" SIZE=20> $TXT{'88'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"reply-to\" VALUE=\"$reply_to\" SIZE=25> $TXT{'89'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"$subject\" SIZE=20> $TXT{'90'}<BR>\n";
	print "<TEXTAREA NAME=\"text\" COLS=$col_width ROWS=$row_height WRAP=\"$word_wrap\">$message</TEXTAREA><BR>\n";
	print "<INPUT TYPE=\"CHECKBOX\" VALUE=\"on\" NAME=\"html\"$html_on> <B>$TXT{'91'}</B><P>\n";
	
	if($spellchecker) {
		print qq!<INPUT TYPE= "BUTTON" VALUE= "$TXT{'92'}" onclick= "var f=document.forms[0]; doSpell ('en', f.text, '$script_directory/sproxy.pl', true);">\n!;
	}
	
	print qq!
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'93'}" NAME="action">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'94'}" NAME="action">
	<P>
	<B>$TXT{'95'}</B> $mytags, &lt;&lt;remove link&gt;&gt;
	</FORM><P><BR>
	
	<A NAME="remove"><H3>$TXT{'82'}</H3></A>
	$TXT{'96'}
	$TXT{'87'}<P>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="type" VALUE="remove">
	!;
	
	open(MESSAGEFILE, "$base_dir/autoresponders/$FORM{'name'}.remove");
	@MESSAGE =<MESSAGEFILE>;
	close(MESSAGEFILE);
	chomp($from = shift(@MESSAGE));
	chomp($reply_to = shift(@MESSAGE));
	chomp($subject = shift(@MESSAGE));
	chomp($html = shift(@MESSAGE));
	$message = join("",@MESSAGE);
	
	if(! $from) {
		$from = $admin_name;
	}
	
	if(! $reply_to) {
		$reply_to = $admin_email_address;
	}
	
	if($html eq "on") {
		$html_on = "CHECKED=\"CHECKED\"";
	}
	else {
		$html_on = "";
	}
	
	print "<INPUT TYPE=\"TEXT\" NAME=\"from\" VALUE=\"$from\" SIZE=20> $TXT{'88'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"reply-to\" VALUE=\"$reply_to\" SIZE=25> $TXT{'89'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"$subject\" SIZE=20> $TXT{'90'}<BR>\n";
	print "<TEXTAREA NAME=\"text\" COLS=$col_width ROWS=$row_height WRAP=\"$word_wrap\">$message</TEXTAREA><BR>\n";
	print "<INPUT TYPE=\"CHECKBOX\" VALUE=\"on\" NAME=\"html\"$html_on> <B>$TXT{'91'}</B><P>\n";
	
	if($spellchecker) {
		print qq!<INPUT TYPE= "BUTTON" VALUE= "$TXT{'92'}" onclick= "var f=document.forms[1]; doSpell ('en', f.text, '$script_directory/sproxy.pl', true);">\n!;
	}
	
	print qq!
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'93'}" NAME="action">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'94'}" NAME="action"><P>
	<B>$TXT{'95'}:</B> $mytags
	</FORM><P><BR>
	
	<A NAME="notify"><H3>$TXT{'83'}</H3></A>
	$TXT{'97'}<P>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="type" VALUE="notify">
	!;
	
	open(MESSAGEFILE, "$base_dir/autoresponders/$FORM{'name'}.notify");
	@MESSAGE =<MESSAGEFILE>;
	close(MESSAGEFILE);
	chomp($from = shift(@MESSAGE));
	chomp($reply_to = shift(@MESSAGE));
	chomp($subject = shift(@MESSAGE));
	chomp($html = shift(@MESSAGE));
	$message = join("",@MESSAGE);
	
	if(! $from) {
		$from = "<<email>>";
	}
	if(! $reply_to) {
		$reply_to = "<<email>>";
	}
	
	if($html eq "on") {
		$html_on = "CHECKED=\"CHECKED\"";
	}
	else {
		$html_on = "";
	}
	
	print "<INPUT TYPE=\"TEXT\" NAME=\"from\" VALUE=\"$from\" SIZE=20> $TXT{'88'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"reply-to\" VALUE=\"$reply_to\" SIZE=25> $TXT{'89'}<BR>\n";
	print "<INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"$subject\" SIZE=20> $TXT{'90'}<BR>\n";
	print "<TEXTAREA NAME=\"text\" COLS=$col_width ROWS=$row_height WRAP=\"$word_wrap\">$message</TEXTAREA><BR>\n";
	print "<INPUT TYPE=\"CHECKBOX\" VALUE=\"on\" NAME=\"html\"$html_on> <B>$TXT{'91'}</B><P>\n";
	
	if($spellchecker) {
		print qq!<INPUT TYPE= "BUTTON" VALUE= "$TXT{'92'}" onclick= "var f=document.forms[2]; doSpell ('en', f.text, '$script_directory/sproxy.pl', true);">\n!;
	}
	
	print qq!
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'93'}" NAME="action">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'94'}" NAME="action"><P>
	<B>$TXT{'95'}</B> $mytags
	</FORM>
	!;
	
	if($verify_new_users) {
		
		print qq!
		<P><BR>
		<A NAME="verify"><H3>$TXT{'84'}</H3></A>
		$TXT{'98'}
		$TXT{'87'}<P>
		<FORM ACTION="admin.pl" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
		<INPUT TYPE="HIDDEN" NAME="type" VALUE="verify">
		!;
		
		open(MESSAGEFILE, "$base_dir/autoresponders/$FORM{'name'}.verify");
		@MESSAGE =<MESSAGEFILE>;
		close(MESSAGEFILE);
		chomp($from = shift(@MESSAGE));
		chomp($reply_to = shift(@MESSAGE));
		chomp($subject = shift(@MESSAGE));
		chomp($html = shift(@MESSAGE));
		$message = join("",@MESSAGE);
		
		if(! $from) {
			$from = $admin_name;
		}
	
		if(! $reply_to) {
			$reply_to = $admin_email_address;
		}
		
		if($html eq "on") {
			$html_on = "CHECKED=\"CHECKED\"";
		}
		else {
			$html_on = "";
		}
		
		print "<INPUT TYPE=\"TEXT\" NAME=\"from\" VALUE=\"$from\" SIZE=20> $TXT{'88'}<BR>\n";
		print "<INPUT TYPE=\"TEXT\" NAME=\"reply-to\" VALUE=\"$reply_to\" SIZE=25> $TXT{'89'}<BR>\n";
		print "<INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"$subject\" SIZE=20> $TXT{'90'}<BR>\n";
		print "<TEXTAREA NAME=\"text\" COLS=$col_width ROWS=$row_height WRAP=\"$word_wrap\">$message</TEXTAREA><BR>\n";
		print "<INPUT TYPE=\"CHECKBOX\" VALUE=\"on\" NAME=\"html\"$html_on> <B>$TXT{'91'}</B><P>\n";
	
		if($spellchecker) {
			print qq!<INPUT TYPE= "BUTTON" VALUE= "$TXT{'92'}" onclick= "var f=document.forms[3]; doSpell ('en', f.text, '$script_directory/sproxy.pl', true);">\n!;
		}
		
		print qq!
		<INPUT TYPE="SUBMIT" VALUE="$TXT{'93'}" NAME="action"><BR>
		<FONT SIZE=2>$TXT{'99'}<BR>
		$TXT{'100'}</FONT><P>
		<B>$TXT{'95'}</B> $mytags, &lt;&lt;verify link&gt;&gt;
		</FORM>
		!;
	}
	print qq!$TXT{'75'}!;
	&admin_footer;
}

elsif($FORM{'action'} eq "$TXT{'93'}") {
	
	# Edit the autoresponders
	&check_pass;
	
	$FORM{'text'} =~ s/\015\012/\n/gs;
	$FORM{'text'} =~ s/\015/\n/gs;
	
	open(MESSAGE,">$base_dir/autoresponders/$FORM{'name'}.$FORM{'type'}") || &error("$TXT{'1'} $FORM{'name'}.$FORM{'type'}");
	print MESSAGE "$FORM{'from'}\n";
	print MESSAGE "$FORM{'reply-to'}\n";
	print MESSAGE "$FORM{'subject'}\n";
	print MESSAGE "$FORM{'html'}\n";
	print MESSAGE "$FORM{'text'}";
	close(MESSAGE);
	&admin_header;
	
	$TXT{'102'} =~ s/<<name>>/$FORM{'name'}/g;
	
	print qq!
	<H3>$TXT{'101'}</H3>
	$TXT{'102'}
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "$TXT{'94'}") {
	
	&check_pass;
	# Delete the autoresponder	
	if(-e "$base_dir/autoresponders/$FORM{'name'}.$FORM{'type'}") {
		unlink("$base_dir/autoresponders/$FORM{'name'}.$FORM{'type'}") || &admin_error("$TXT{'162'} $FORM{'name'}.$FORM{'type'}");
	}
	&admin_header;
	$TXT{'102'} =~ s/<<name>>/$FORM{'name'}/g;
	print qq!
	<H3>$TXT{'103'}</H3>
	$TXT{'102'}
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "delete") {
	# Delete confirmation page
	&check_pass;
	&admin_header;
	print qq!
	<H3>$TXT{'104'} $FORM{'name'}?</H3>
	<CENTER>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Delete Confirmed">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'105'}">
	</FORM>
	</CENTER>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "Delete Confirmed") {
	# Delete the list
	&check_pass;
	unlink("$base_dir/$FORM{'name'}.info") || &error("$TXT{'163'}");
	
	if(-e "$base_dir/$FORM{'name'}.dat") {
		unlink("$base_dir/$FORM{'name'}.dat") || &error("$TXT{'162'} $FORM{'name'}.dat");
	}
	if(-e "$base_dir/autoresponders/$FORM{'name'}.add") {
		unlink("$base_dir/autoresponders/$FORM{'name'}.add") || &error("$TXT{'162'} $FORM{'name'}.add");
	}
	if(-e "$base_dir/autoresponders/$FORM{'name'}.remove") {
		unlink("$base_dir/autoresponders/$FORM{'name'}.remove") || &error("$TXT{'162'} $FORM{'name'}.remove");
	}
	if(-e "$base_dir/autoresponders/$FORM{'name'}.verify") {
		unlink("$base_dir/autoresponders/$FORM{'name'}.verify") || &error("$TXT{'162'} $FORM{'name'}.verify");
	}
	if(-e "$base_dir/autoresponders/$FORM{'name'}.notify") {
		unlink("$base_dir/autoresponders/$FORM{'name'}.notify") || &error("$TXT{'162'} $FORM{'name'}.notify");
	}
	if(-e "$base_dir/$FORM{'name'}.tmp") {
		unlink("$base_dir/$FORM{'name'}.tmp") || &error("$TXT{'162'} $$FORM{'name'}.tmp");
	}
	if(-e "$base_dir/$FORM{'name'}.out") {
		unlink("$base_dir/$FORM{'name'}.tmp") || &error("$TXT{'162'} $FORM{'name'}.out");
	}
	
	&admin_header;
	print qq!
	<H3>$TXT{'106'}</H3>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "registration") {
	&check_pass;
	&admin_header;
	print qq!
	<FORM ACTION="http://www.web-consult.com/cgi-bin/sys2/register.cgi" METHOD="POST">
	Please enter your registration information below.<P>
	<INPUT TYPE="HIDDEN" NAME="email" VALUE="$admin_email_address">
	<INPUT TYPE="HIDDEN" NAME="script" VALUE="$script_directory/admin.pl">
	 Please enter your registration number<BR>
	<INPUT TYPE="TEXT" NAME="regnum" SIZE=15><P>
	
	Please enter your password<BR>
	<FONT SIZE=1>(Note: You should enter the password you specified when you purchased Post Office,
	not the password for your Post Office administration.  If you do not remember your password, click <A HREF="http://www.cgiparadise.com/forgot.html" TARGET="_new">here</A>.)</FONT><BR>
	<INPUT TYPE="PASSWORD" NAME="password" SIZE=15><P>
	<INPUT TYPE="SUBMIT" VALUE="Submit Registration">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "regapproved") {
	&check_pass;
	open(REG,">$base_dir/regit.num") || &admin_error("Unable to create Post Office registration file");
	print REG "$FORM{'regnum'}";
	close(REG);
	
	&admin_header;
	print qq!
	<H3>Registration approved</H3>
	<B>Back to <A HREF="admin.pl?action=main">Administration Home</A></B>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "settings") {
	# Output the settings page
	&check_pass;
	
	&admin_header;
	print qq!
	<FORM ACTION="admin.pl" METHOD="POST">
	$TXT{'107'}<P>
	<BR>
	<H2>$TXT{'108'}</H2>
	<B>$TXT{'109'}</B>
	$TXT{'110'}<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="base_dir" VALUE="$base_dir"><P>
	
	<B>$TXT{'111'}</B>
	$TXT{'112'}<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="script_directory" VALUE="$script_directory"><P>
	
	<B>$TXT{'206'}</B>
	$TXT{'205'}<BR>
	<INPUT TYPE="TEXT" SIZE=40 NAME="path_to_perl" VALUE="$path_to_perl"><P>
	
	$TXT{'113'}<BR>
	<SELECT NAME="mail_type">
	!;
	
	if($mail_type) {
		print qq!
		<OPTION VALUE="0">Sendmail</OPTION>
		<OPTION VALUE="1" SELECTED>SMTP Server</OPTION>
		!;
	}
	else {
		print qq!
		<OPTION VALUE="0" SELECTED>Sendmail</OPTION>
		<OPTION VALUE="1">SMTP Server</OPTION>
		!;
	}
	
	print qq!
	</SELECT><P><BR>
	<H2>$TXT{'114'}</H2>
	$TXT{'115'}<P>
	
	$TXT{'116'}<BR>
	<INPUT TYPE="TEXT" SIZE=25 NAME="smtp_server" VALUE="$smtp_server"><P>
	
	$TXT{'117'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="smtp_port" VALUE="$smtp_port"><P>
	<BR>
	<H2>$TXT{'118'}</H2>
	$TXT{'119'}<P>
	$TXT{'120'}<BR>
	<INPUT TYPE="TEXT" SIZE=25 NAME="mailprog" VALUE="$mailprog"><P>
	<BR>
	<H2>$TXT{'121'}</H2>
	$TXT{'122'} <P>
	
	
	$TXT{'123'} <SELECT NAME="language">
	!;
	
	opendir(CGI,"$this_dir") || &admin_error("$TXT{'164'}");
	while($file = readdir(CGI)) {
		if($file =~ /^(.*)\.lib$/) {
			$mylang = $1;
			if($mylang =~ /$language/i) {
				print qq!<OPTION VALUE="$mylang" SELECTED>$mylang</OPTION>!;
			}
			else {
				print qq!<OPTION VALUE="$mylang">$mylang</OPTION>!;
			}
		}
	}
	closedir(CGI);
	
	print qq!
	</SELECT><P>
	!;
	
	if($spellchecker) {
		print qq!<INPUT TYPE="CHECKBOX" NAME="spellchecker" VALUE="1" CHECKED="CHECKED">\n!;
	}
	else {
		print qq!<INPUT TYPE="CHECKBOX" NAME="spellchecker" VALUE="1">\n!;
	}
	if($allow_duplicates) {
		print qq!$TXT{'124'}<P>
		<INPUT TYPE="CHECKBOX" NAME="allow_duplicates" VALUE="1" CHECKED="CHECKED">!;
	}
	else {
		print qq!$TXT{'124'}<P>
		<INPUT TYPE="CHECKBOX" NAME="allow_duplicates" VALUE="1">!;
	}
	if($verify_new_users) {
		print qq!
		$TXT{'125'}<P>
		<INPUT TYPE="CHECKBOX" NAME="verify_new_users" VALUE="1" CHECKED="CHECKED">
		!;
	}
	else {
		print qq!
		$TXT{'125'}<P>
		<INPUT TYPE="CHECKBOX" NAME="verify_new_users" VALUE="1">
		!;
	}
	
	if($continue_when_interrupted) {
		print qq!
		$TXT{'126'}<P>
		<INPUT TYPE="CHECKBOX" NAME="continue_when_interrupted" VALUE="1" CHECKED="CHECKED">
		!;
	}
	else {
		print qq!
		$TXT{'126'}<P>
		<INPUT TYPE="CHECKBOX" NAME="continue_when_interrupted" VALUE="1">
		!;
	}
	
	if($log_opt_out) {
		print qq!
		$TXT{'127'}<P>
		<INPUT TYPE="CHECKBOX" NAME="log_opt_out" VALUE="1" CHECKED="CHECKED">
		!;
	}
	else {
		print qq!
		$TXT{'127'}<P>
		<INPUT TYPE="CHECKBOX" NAME="log_opt_out" VALUE="1">
		!;
	}
	
	open(HEADER,"$base_dir/header.txt") || &admin_error("$TXT{'2'} header.txt");
	@HEADER =<HEADER>;
	close(HEADER);
	
	open(FOOTER,"$base_dir/footer.txt") || &admin_error("$TXT{'2'} footer.txt");
	@FOOTER =<FOOTER>;
	close(FOOTER);
	
	
	if(! -e "$base_dir/autoresponders/all.verify") {
		open(MESSAGE,">$base_dir/autoresponders/all.verify") || &admin_error("$TXT{'1'} all.verify");
		print MESSAGE "$admin_name\n";
		print MESSAGE "$admin_email_address\n";
		print MESSAGE "Verify your email\n";
		print MESSAGE "\n";
		print MESSAGE "Thank you for signing up for our mailing list.  To finalize your\n";
		print MESSAGE "addition to our mailing list please follow the link below.\n";
		print MESSAGE "Thank you!\n\n";

		print MESSAGE "<<verify link>>\n\n";

		print MESSAGE "This mailing list is powered by: Post Office Pro $version\n";
		print MESSAGE "http://www.cgiparadise.com";
		close(MESSAGE);
	}
	
	open(AUTORESPONDER,"$base_dir/autoresponders/all.verify") || &admin_error("$TXT{'2'} all.verify");
	@AUTO =<AUTORESPONDER>;
	close(AUTO);
	
	
	$header = join("",@HEADER);
	$footer = join("",@FOOTER);
	
	$from = shift(@AUTO);
	$reply_to = shift(@AUTO);
	$subject = shift(@AUTO);
	$html = shift(@AUTO);
	$autoresponder = join("",@AUTO);
	if($html =~ /on/i) {
		$CHECKED = "CHECKED=\"CHECKED\"";
	}
	print qq!
	
	$TXT{'128'}<P>
	
	<B>$TXT{'129'}</B><BR>
	<INPUT TYPE="TEXT" SIZE=35 NAME="admin_name" VALUE="$admin_name"><P>
	
	<B>$TXT{'130'}</B><BR>
	<INPUT TYPE="TEXT" SIZE=35 NAME="admin_email_address" VALUE="$admin_email_address"><P>
	
	$TXT{'131'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="backup" VALUE="$backup"><P>
	
	$TXT{'132'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="temp_file_days" VALUE="$temp_file_days"><P>
	
	$TXT{'133'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="max_groups" VALUE="$max_groups"><P>
	
	$TXT{'134'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="batch" VALUE="$batch"><P>
	
	$TXT{'135'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="wait_time" VALUE="$wait_time"><P>
	
	$TXT{'136'}<BR>
	<TEXTAREA NAME="header" COLS=$col_width ROWS=$row_height WRAP="off">$header</TEXTAREA><P>
	
	$TXT{'137'}<BR>
	<TEXTAREA NAME="footer" COLS=$col_width ROWS=$row_height WRAP="off">$footer</TEXTAREA><P>
	
	<B>$TXT{'84'}</B><BR>
	<INPUT TYPE="TEXT" SIZE=20 NAME="autoresponder_from" VALUE="$from"> From<BR>
	<INPUT TYPE="TEXT" SIZE=25 NAME="autoresponder_reply_to" VALUE="$reply_to"> Reply-to Address<BR>
	<INPUT TYPE="TEXT" SIZE=20 NAME="autoresponder_subject" VALUE="$subject"> Subject<BR>
	<TEXTAREA NAME="autoresponder" COLS=$col_width ROWS=$row_height WRAP="off">$autoresponder</TEXTAREA><BR>
	HTML Email? <INPUT TYPE="CHECKBOX" NAME="autoresponder_html" VALUE="on" $CHECKED>
	
	<P><BR>
	<H2>$TXT{'138'}</H2>
	$TXT{'139'}<BR>
	<SELECT NAME="word_wrap">
	!;
	
	if($word_wrap =~ /Off/i) {
		print "<OPTION SELECTED>Off</OPTION>\n";
	}
	else {
		print "<OPTION>Off</OPTION>\n";
	}
	
	if($word_wrap =~ /Virtual/i) {
		print "<OPTION SELECTED>Virtual</OPTION>\n";
	}
	else {
		print "<OPTION>Virtual</OPTION>\n";
	}
	
	if($word_wrap =~ /Physical/i) {
		print "<OPTION SELECTED>Physical</OPTION>\n";
	}
	else {
		print "<OPTION>Physical</OPTION>\n";
	}
	
	print qq!
	</SELECT>
	<P>
	
	$TXT{'140'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="col_width" VALUE="$col_width"><P>
	
	$TXT{'141'}<BR>
	<INPUT TYPE="TEXT" SIZE=5 NAME="row_height" VALUE="$row_height"><P>
	
	<INPUT TYPE="HIDDEN" NAME="lockfile_maxtry" VALUE="$lockfile_maxtry">
	<INPUT TYPE="HIDDEN" NAME="max_try" VALUE="$max_try">
	<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$this_dir">
	<INPUT TYPE="HIDDEN" NAME="version" VALUE="4.0">
	<INPUT TYPE="HIDDEN" NAME="max_mail_try" VALUE="$max_mail_try">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="Edit Settings">
	
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'142'}">
	<INPUT TYPE="RESET" VALUE="$TXT{'143'}">
	</FORM><P>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "Edit Settings") {
	&check_pass;
	
	$FORM{'admin_email_address'} =~ s/\@/\\@/;
	$FORM{'admin_name'} =~ s/\@/\\@/;
	
	if($FORM{'script_directory'} !~ /^http/i) {
		&admin_error("$TXT{'144'}");
	}
	
	$this_dir =~ s/\\/\//g;
	if(! open(CONFIG,">$this_dir/config.pl")) {
		#if(! open(CONFIG,">config.pl")) {
			&admin_error("$TXT{'145'}");
		#}
	}
	
	foreach $key (keys %FORM) {
		if($key eq "action" || $key eq "header" || $key eq "footer" || $key =~ /^autoresponder/i) {
			next;
		}
		print CONFIG "\$$key = \"$FORM{$key}\";\n";
	}
	print CONFIG "1;\n";
	close(CONFIG);
	
	$FORM{'header'} =~ s/\015\012/\n/gs;
	$FORM{'header'} =~ s/\015/\n/gs;
	#$FORM{'header'} =~ s/\n/\015\012/gs;
	
	open(HEAD,">$FORM{'base_dir'}/header.txt") || &admin_error("$TXT{'1'} header.txt");
	print HEAD "$FORM{'header'}";
	close(HEAD);
	
	$FORM{'footer'} =~ s/\015\012/\n/gs;
	$FORM{'footer'} =~ s/\015/\n/gs;
	
	open(FOOT,">$FORM{'base_dir'}/footer.txt") || &admin_error("$TXT{'1'} footer.txt");
	print FOOT "$FORM{'footer'}";
	close(FOOT);
	
	$FORM{'autoresponder'} =~ s/\015\012/\n/gs;
	$FORM{'autoresponder'} =~ s/\015/\n/gs;
	
	open(AUTO,">$FORM{'base_dir'}/autoresponders/all.verify") || &admin_error("$TXT{'1'} all.verify");
	print AUTO "$FORM{'autoresponder_from'}\n";
	print AUTO "$FORM{'autoresponder_reply_to'}\n";
	print AUTO "$FORM{'autoresponder_subject'}\n";
	print AUTO "$FORM{'autoresponder_html'}\n";
	print AUTO "$FORM{'autoresponder'}";
	close(AUTO);
	
	&admin_header;
	print qq!
	<H3>$TXT{'146'}</H3>
	$TXT{'147'}<P>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "backup") {
	# Backup confirmation page
	&check_pass;
	
	open(LAST,"$base_dir/backup/last_backup.txt") || &admin_error("$TXT{'2'} last_backup.txt");
	chomp($mytime =<LAST>);
	close(LAST);
	
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime($mytime);
	$year += 1900;
	
	if(length($min) < 2) {
		$min = "0$min";
	}
	
	$date = "$days[$wday], $months[$mon] $mday, $year on $hour:$min (GMT)";
	
	&admin_header;
	print qq!
	<H3>$TXT{'148'} $FORM{'name'}?</H3>
	<B>$TXT{'149'} $date</B><P>
	$TXT{'150'}<P>
	<CENTER>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="loadbackup">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'151'}">
	</FORM><P>
	</CENTER>
	$TXT{'75'}
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "loadbackup") {
	# Load the backups!
	&check_pass;
	
	opendir(BACKUP,"$base_dir/backup") || &error("$TXT{'165'}");
	$i = 0;
	while($file = readdir(BACKUP)) {
			
		if($file =~ /$FORM{'name'}\..+/) {
			open(BFILE,"$base_dir/backup/$file") || &error("$TXT{'2'} backup/$file.<BR>$TXT{'166'}");
			@BDATA =<BFILE>;
			close(BFILE);
				
			if(-e "$base_dir/$file") {
				open(OFILE,"$base_dir/$file") || &error("$TXT{'2'} $file");
				@ODATA =<OFILE>;
				close(OFILE);
					
				open(BFILE,">$base_dir/backup/$file") || &error("$TXT{'1'} backup/$file");
				print BFILE @ODATA;
				close(BFILE);
			}
				
			open(OFILE,">$base_dir/$file") || &error("$TXT{'1'} $file");
			print OFILE @BDATA;
			close(OFILE);
			$i++;
		}
	}
	closedir(BACKUP);
	
	&admin_header;
	$TXT{'153'} =~ s/<<i>>/$i/g;
	print qq!
	<H3>$TXT{'152'}</H3>
	$TXT{'153'}<P>
	$TXT{'75'}
	!;
	&admin_footer;
}
elsif($FORM{'action'} eq "add" || $FORM{'action'} eq "added") {
	
	&check_pass;
	
	if($FORM{'action'} eq "added") {
		
		&admin_error("$TXT{'6'}") unless $FORM{'email'} =~ /.*\@.*\..*/;
		
		if($FORM{'email'} =~ /\s$/) {
    		chop($FORM{'email'});
    	}
    	
    	if(! $allow_duplicates) {
    		# Check for duplicate email addresses
    		open(LIST,"$base_dir/$FORM{'groupname'}.dat") || &admin_error("$TXT{'2'} $FORM{'groupname'}.dat");
    		while($line =<LIST>) {
    			if($line =~ /$FORM{'email'}/i) {
    				$txt = $TXT{'13'};
    				$txt =~ s/<<groupname>>/$FORM{'groupname'}/g;
    				close(LIST);
    				&admin_error("$txt");
    			}
    		}
    		close(LIST);
    	}
    	
    	if($log_opt_out && -e "$base_dir/$FORM{'groupname'}.out" && $FORM{'proceed'} ne "yes") {
    		open(OPTOUT,"$base_dir/$FORM{'groupname'}.out") || &admin_error("$TXT{'2'} $FORM{'groupname'}.out");
    		while($line =<OPTOUT>) {
    			chomp($line);
    			if($line =~ /$FORM{'email'}/i) {
    				close(OPTOUT);
    				&admin_header;
    				print qq!
    				<FORM ACTION="admin.pl" METHOD="POST">
    				<H3>$TXT{'9'}</H3>
    				$TXT{'154'}<P><UL>
    				!;
    		
    				foreach $key (keys %FORM) {
    					print qq!
    					<INPUT TYPE="HIDDEN" NAME="$key" VALUE="$FORM{$key}">
    					!;
    				}
    		
    				print qq!
    				<BR>
    				<INPUT TYPE="HIDDEN" NAME="proceed" VALUE="yes">
    				<INPUT TYPE="SUBMIT" VALUE="$TXT{'11'}">
    				</UL>
    				</FORM>
    				!;
    				&admin_footer;
    				exit;
    			}
    		}
    		close(OPTOUT);
    	}
    	
    	if($log_opt_out && $FORM{'proceed'} eq "yes") {
    		if(-e "$base_dir/$FORM{'groupname'}.out") {
    			&file_lock("$FORM{'groupname'}");
    			open(OUT,"$base_dir/$FORM{'groupname'}.out") || &error("$TXT{'2'} $FORM{$field}.out");
    			@OUTDAT =<OUT>;
    			close(OUT);
    			
    			open(OUT,">$base_dir/$FORM{'groupname'}.out") || &error("$TXT{'1'} $FORM{$field}.out");
    			foreach $out_email (@OUTDAT) {
    				chomp($out_email);
    				if($out_email !~ /$FORM{'email'}/i) {
    					print OUT "$out_email\n";
    				}
    			}
    			close(OUT);
    			&file_unlock("$FORM{'groupname'}");
    			undef(@OUTDAT);
    		}
    	}
    	
		&file_lock("$FORM{'groupname'}");
		
		open(INFO,"$base_dir/$FORM{'groupname'}.info") || &admin_error("$TXT{'2'} $FORM{'groupname'}.info");
		@MYINFO =<INFO>;
		close(INFO);
	
		chomp($MYINFO[0]);
		chomp($MYINFO[1]);
	
		@fields = split(/\&\&/,$MYINFO[1]);
		
		$entry = "";
		foreach $field (@fields) {
			$entry .= "$FORM{$field}&&";
		}
		
		chop($entry);
		chop($entry);
		
		open(DAT,">>$base_dir/$FORM{'groupname'}.dat") || &admin_error("$TXT{'2'} $FORM{'groupname'}.dat");
		print DAT "$entry\n";
		close(DAT);
		
		$MYINFO[0] += 1;
		
		open(INFO, ">$base_dir/$FORM{'groupname'}.info") || &admin_error("$TXT{'1'} $FORM{'groupname'}.info");
    	print INFO "$MYINFO[0]\n";
    	print INFO "$MYINFO[1]";
	    close(INFO);
	    		
		&file_unlock("$FORM{'groupname'}");
	}
	
	&admin_header;
	
	if($FORM{'action'} eq "add") {
		
		open(INFO,"$base_dir/$FORM{'groupname'}.info") || &admin_error("$TXT{'2'} $FORM{'groupname'}.info");
		@MYINFO =<INFO>;
		close(INFO);
		@fields = split(/\&\&/,$MYINFO[1]);
		
		print qq!
		<H3>$TXT{'155'}</H3>
		$TXT{'156'}<P>
		!;
	}
	else {
		print qq!
		<H3>$TXT{'157'}</H3>
		$TXT{'156'}<P>
		!;
	}
	
	print qq!
	<TABLE BORDER=0>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="added">
	<INPUT TYPE="HIDDEN" NAME="groupname" VALUE="$FORM{'groupname'}">
	!;
	
	foreach $field (@fields) {
		print qq!
		<TR><TD>$field</TD><TD>
		<INPUT TYPE="TEXT" NAME="$field" SIZE=25>
		</TD></TR>
		!;
	}
	print qq!
	</TABLE>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'155'}">
	</FORM><P>
	$TXT{'75'}
	!;
	&admin_footer;
}
elsif($FORM{'action'} eq "viewlog") {
	
	&check_pass;
	
	if(-e "$base_dir/log.txt") {
		open(LOG,"$base_dir/log.txt") || &admin_error("$TXT{'167'}");
		@MYLOG =<LOG>;
		close(LOG);
		$mylog = join("<BR>",@MYLOG);
	}
	else {
		$mylog = "<B>$TXT{'158'}</B>\n";
	}
	
	&admin_header;
	print qq!
	<H3>$TXT{'159'}</H3>
	!;
	print $mylog;
	&admin_footer;
	
}
elsif($FORM{'action'} eq "logout") {
	&check_pass;
	unlink("$base_dir/$cookie.session");
	&setcookie("0");
	&admin_header;
	print qq!
	<H3>$TXT{'160'}</H3>
	
	$TXT{'161'}<P>
	<FORM ACTION="admin.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="main">
	<INPUT TYPE="TEXT" SIZE=15 NAME="username"> $TXT{'33'}<BR>
	<INPUT TYPE="PASSWORD" SIZE=15 NAME="password"> $TXT{'34'}<BR><BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
	</FORM>
	!;
	&admin_footer;
}

elsif($FORM{'action'} eq "tidyup") {
	&check_pass;
	if($FORM{'confirm'} eq "yes") {
		
		&file_lock("$FORM{'name'}");
	
		open(DAT,"$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'2'} $FORM{'name'}.dat");
		@MYDAT =<DAT>;
		close(DAT);
		
		if(-e "$base_dir/$FORM{'name'}.out") {
			open(DAT,"$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'2'} $FORM{'name'}.out");
			@OUTDAT =<DAT>;
			close(DAT);
		}
		
		$num = $#MYDAT + 1;
		
		open(INFO, "$base_dir/$FORM{'name'}.info") || &error("$TXT{'2'} $FORM{$field}.info");
    	@MYINFO =<INFO>;
    	close(INFO);
    		
    	chomp($MYINFO[0]);
    	chomp($MYINFO[1]);
    	
    	@fields = split(/\&\&/,$MYINFO[1]);
    	
    	$key = 0;
    	foreach $field (@fields) {
    		if($field eq "email") {
    			last;
    		}
    		$key++;
    	}
    		
		open(DAT,">$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'1'} $FORM{'name'}.dat");
		MAIN: foreach $line (@MYDAT) {
			chomp($line);
			chomp($line);
			@data = split(/\&\&/,$line);
			$email = $data[$key];
			$email =~ tr/[A-Z]/[a-z]/;
			if($LIST{$email}) {
				$num -= 1;
				next;
			}
			else {
				$LIST{$email} = 1;
				foreach $out_email (@OUTDAT) {
					chomp($out_email);
					if($out_email =~ /$email/i) {
						$num -= 1;
						next MAIN;
					}
				}
				print DAT "$line\n";
			}
		}
		close(DAT);
		
		open(INFO,">$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'1'} $FORM{'name'}.info");
		print INFO "$num\n";
		print INFO "$MYINFO[1]";
		close(INFO);
		
		&file_unlock("$FORM{'name'}");
		&admin_header;
		print qq!
		<H3>$TXT{'295'}</H3>
		$TXT{'294'}
		$TXT{'75'}
		!;
		&admin_footer;
	}
	else {
		&admin_header;
		print qq!
		<H3>$TXT{'296'}</H3>
		
		$TXT{'297'}<P>
		
		<CENTER>
		<FORM ACTION="admin.pl" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="tidyup">
		<INPUT TYPE="HIDDEN" NAME="confirm" VALUE="yes">
		<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
		<INPUT TYPE="SUBMIT" VALUE="$TXT{'298'}">
		</FORM>
		</CENTER>
		!;
		&admin_footer;
	}
}

elsif($FORM{'action'} eq "spellchecker") {
	print "Content-Type: text/javacript\n\n";
	&spellchecker;
}
else {
	&admin_error("$TXT{'4'}");
}
