#! /usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on January 25, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^export\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}
require 'library.pl';
require 'config.pl';
require "$language.lib";
&parse_form;

if($FORM{'action'} eq "") {
	
	&check_pass;
	&admin_header;
	
	print qq!
	<B></B><P>
	
	<FORM ACTION="export.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="username" VALUE="$FORM{'username'}">
	<INPUT TYPE="HIDDEN" NAME="password" VALUE="$FORM{'password'}">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="export">
	
	$TXT{'244'} <INPUT TYPE="TEXT" SIZE=5 NAME="delimiter"><BR>
	<FONT SIZE=1>$TXT{'277'}</FONT><P>
	
	$TXT{'245'}<BR>
	<INPUT TYPE="radio" NAME="quote" VALUE="single"> $TXT{'246'} (')
	<INPUT TYPE="radio" NAME="quote" VALUE="double"> $TXT{'247'}<P>
	
	$TXT{'248'}<BR>
	<INPUT TYPE="RADIO" NAME="format" VALUE="windows"> Windows
	<INPUT TYPE="RADIO" NAME="format" VALUE="unix"> Unix<P>
	
	$TXT{'249'}<BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'47'}">
	!;
	
	&admin_footer;
	
}

if($FORM{'action'} eq "export") {
	
	&check_pass;
	&admin_error("Please specify a delimiter!") if $FORM{'delimiter'} eq "";
	
	print "Content-Type: text/plain\n\n";
	
	open(LIST,"$base_dir/$FORM{'name'}.dat") || &error("$TXT{'2'} $base_dir/$FORM{'name'}.dat");
	while($line =<LIST>) {
		chomp($line);
		chomp($line);
		if($FORM{'quote'} eq "single") {
			$line =~ s/\&\&/\'$FORM{'delimiter'}\'/g;
			$line = "\'$line\'";
		}
		elsif($FORM{'quote'} eq "double") {
			$line =~ s/\&\&/\"$FORM{'delimiter'}\"/g;
			$line = "\"$line\"";
		}
		else {
			$line =~ s/\&\&/$FORM{'delimiter'}/g;
		}
		print "$line";
		
		if($FORM{'format'} eq "windows") {
			print "\r";
		}
		print "\n";
		
	}
	close(LIST);
	
}