#! /usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on January 25, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^formwizard\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
require 'config.pl';
require "$language.lib";
&parse_form;
&check_pass;

if($FORM{'action'} eq "") {
	&admin_header;
	print qq!
	$TXT{'207'}<P>
	
	<H3>$TXT{'208'}</H3>
	
	<A HREF="formwizard.pl?action=step2&type=1"><B>$TXT{'209'}</B></A><BR>
	$TXT{'210'}<P>
	
	<A HREF="formwizard.pl?action=step2&type=2"><B>$TXT{'211'}</B></A><BR>
	$TXT{'212'}<P>
	
	<A HREF="formwizard.pl?action=step2&type=3"><B>$TXT{'213'}</B></A><BR>
	$TXT{'214'}<P>
	
	<A HREF="formwizard.pl?action=step2&type=4"><B>$TXT{'215'}</B></A><BR>
	$TXT{'216'}<P>
	
	<A HREF="formwizard.pl?action=step2&type=5"><B>$TXT{'217'}</B></A><BR>
	$TXT{'218'}<P>
	
	<A HREF="formwizard.pl?action=step2&type=6"><B>$TXT{'219'}</B></A><BR>
	$TXT{'220'}<P>
	!;
	&admin_footer;	
}

elsif($FORM{'action'} eq "step2") {
	
	@GROUPS = ();
	opendir(BASE,"$base_dir") || &admin_error("$TXT{'0'}");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			push(@GROUPS,"$1");
		}
	}
	closedir(BASE);
	
	if($FORM{'type'} < 3) {
	
		&admin_header;
		print qq!
		<H3>Step 2</H3>
		<FORM ACTION="formwizard.pl" METHOD="POST">
		$TXT{'221'}<BR>
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step3">
		<INPUT TYPE="HIDDEN" NAME="type" VALUE="$FORM{'type'}">
		<SELECT NAME="group1">
		<OPTION VALUE="">-- $TXT{'222'} --</OPTION>
		!;
		
		foreach $group (@GROUPS) {
			print "<OPTION VALUE=\"$group\">$group</OPTION>\n";
		}
		
		print qq!
		</SELECT><P>
		<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
		</FORM>
		!;
		&admin_footer;
	}
	else {
		$num = $FORM{'num'} || 1;
		$mynum = $num;
		$mynum += 1;
		
		&admin_header;
		print qq!
		<H3>Step 2</H3>
		<FORM ACTION="formwizard.pl" METHOD="POST">
		!;
		
		if($num > 1) {
			print qq!
			<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2 BGCOLOR="FFFFFF">	
			<TR BGCOLOR="FFDDDD"><TD><B>$TXT{'223'}</B></TD></TR>
			!;
			for($i=1;$i < $num;$i++) {
				$field = "group$i";
				print qq!
				<INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}">
				<TR BGCOLOR="DDDDDD"><TD>$FORM{$field}</TD></TR>
				!;
			}
			print "</TABLE><P>\n";
		}
		
		print qq!
		$TXT{'221'}<BR>
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
		<INPUT TYPE="HIDDEN" NAME="type" VALUE="$FORM{'type'}">
		<INPUT TYPE="HIDDEN" NAME="num" VALUE="$mynum">
		<SELECT NAME="group$num">
		<OPTION VALUE="">-- $TXT{'222'} --</OPTION>
		!;
		
		foreach $group (@GROUPS) {
			print "<OPTION VALUE=\"$group\">$group</OPTION>\n";
		}
		
		print qq!
		</SELECT><P>
		<TABLE BORDER=0>
		<TR><TD>
		<INPUT TYPE="SUBMIT" VALUE="$TXT{'224'}"><BR>
		</TD>
		</FORM>
		!;
		
		if($num > 1) {
			print qq!
			<FORM ACTION="formwizard.pl" METHOD="POST">
			<TD>
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step3">
			<INPUT TYPE="HIDDEN" NAME="type" VALUE="$FORM{'type'}">
			!;
			for($i=1;$i < $num;$i++) {
				$field = "group$i";
				print qq!
				<INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}">
				!;
			}
			print "<INPUT TYPE=\"HIDDEN\" NAME=\"num\" VALUE=\"$num\">\n";
			print "<INPUT TYPE=\"SUBMIT\" VALUE=\"$TXT{'225'}\"><BR></TD></TR></FORM></TABLE>\n";
		}
		else {
			print "</TD></TR></TABLE>\n";
		}
		&admin_footer;
	}
}

elsif($FORM{'action'} eq "step3") {
	
	@GROUPS = ();
	opendir(BASE,"$base_dir") || &admin_error("$TXT{'0'}");
	while($file = readdir(BASE)) {
		if($file =~ /^(.*)\.info$/) {
			push(@GROUPS,"$1");
		}
	}
	closedir(BASE);
	
	if(! $FORM{'num'}) {
		$FORM{'num'} = 2;
	}
	
	@myfields = ();
			
	for($i=1;$i < $FORM{'num'};$i++) {
		
		$field = "group$i";
		
		open(INFO,"$base_dir/$FORM{$field}.info") || &admin_error("$TXT{'2'} $FORM{$field}.info");
		@MYINFO =<INFO>;
		close(INFO);
		
		@fields = split(/\&\&/,$MYINFO[1]);
		MAIN: foreach $field (@fields) {
			foreach $myfields (@myfields) {
				if($field eq "$myfields") {
					next MAIN;
				}
			}
			push(@myfields,$field);
		}
	}
	
	&admin_header;
	print qq!
	<H3>Step 3</H3>
	
	$TXT{'226'}<P>
	<FORM ACTION="formwizard.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="step4">
	<INPUT TYPE="HIDDEN" NAME="field_num" VALUE="$#myfields">
	!;
	foreach $key (keys %FORM) {
		if($key eq "action") {
			next;
		}
		print "<INPUT TYPE=\"HIDDEN\" NAME=\"$key\" VALUE=\"$FORM{$key}\">\n";
	}
	print qq!
	<B>$TXT{'227'}</B> (Optional)<BR>$TXT{'228'}<BR>
	<INPUT TYPE="TEXT" NAME="subscribe_redirect" SIZE=40 VALUE="http://"><P>
	
	<B>$TXT{'229'}</B> (Optional)<BR>$TXT{'230'}<BR>
	<INPUT TYPE="TEXT" NAME="unsubscribe_redirect" SIZE=40 VALUE="http://"><P>
	
	<B>$TXT{'231'}</B> $TXT{'232'}<BR>
	<INPUT TYPE="TEXT" NAME="verify_redirect" SIZE=40 VALUE="http://"><P>

	<B>$TXT{'233'}
	<P>
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2>
	<TR><TD><B>$TXT{'234'}</B></TD><TD ALIGN="CENTER"><B>$TXT{'235'}</B></TD><TD ALIGN="CENTER"><B>$TXT{'236'}</B></TD></TR>
	!;
	$i = 1;
	foreach $myfield (@myfields) {
		
		if($myfield eq "date" || $myfield eq "ip") {
			$i++;
			next;
		}
		
		if($myfield eq "email") {
			print qq!
			<TR>
			<TD> $myfield </TD>
			<TD ALIGN="CENTER"> <INPUT TYPE="CHECKBOX" NAME="use$i" VALUE="$myfield" CHECKED="CHECKED"> </TD>
			<TD ALIGN="CENTER"> <INPUT TYPE="CHECKBOX" NAME="require$i" VALUE="$myfield" CHECKED="CHECKED"> </TD>
			</TR>
			!;
		}
		else {
			print qq!
			<TR>
			<TD> $myfield </TD>
			<TD ALIGN="CENTER"> <INPUT TYPE="CHECKBOX" NAME="use$i" VALUE="$myfield"> </TD>
			<TD ALIGN="CENTER"> <INPUT TYPE="CHECKBOX" NAME="require$i" VALUE="$myfield"> </TD>
			</TR>
			!;
		}
		$i++;
	}
	
	print "</TABLE><P>";
	
	if($FORM{'type'} == 3 || $FORM{'type'} == 6) {
		print qq!
		<B>$TXT{'237'}</B><BR>$TXT{'238'}<BR>
		<SELECT NAME="autoresponder">
		<OPTION VALUE="all">All</OPTION>
		!;
		
		foreach $group (@GROUPS) {
			print "<OPTION VALUE=\"$group\">$group</OPTION>\n";
		}
		
		print "</SELECT><P>\n";
	}
	
	print qq!
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'66'}">
	</FORM>
	!;
	&admin_footer;	
}

elsif($FORM{'action'} eq "step4") {
	&admin_header;
	print qq!
	<H3>$TXT{'239'}</H3>
	$TXT{'240'}<P>
	
	&lt;FORM ACTION="$script_directory/manager.pl" METHOD="POST"&gt;<BR>
	&lt;INPUT TYPE="HIDDEN" NAME="autoresponder" VALUE="$FORM{'autoresponder'}"&gt;<BR>
	!;
	
	$FORM{'field_num'} += 1;
	
	@required = ();
	
	for($i=1;$i<=$FORM{'field_num'};$i++) {
		$field = "use$i";
		if($FORM{$field}) {
			print qq!&lt;INPUT TYPE="TEXT" NAME="$FORM{$field}" SIZE=20&gt; $FORM{$field}&lt;BR&gt;<BR>\n!;
		}
		$field = "require$i";
		if($FORM{$field}) {
			push(@required,"$FORM{$field}");
		}
	}
	
	$required = join(",",@required);
	print qq!&lt;INPUT TYPE="HIDDEN" NAME="required" VALUE="$required"&gt;<BR>\n!;
	
	if($FORM{'type'} <= 2) {
		print qq!
		&lt;INPUT TYPE="HIDDEN" NAME="group1" VALUE="$FORM{'group1'}"&gt;<BR>
		!;
	}
	else {
		
		print qq!&lt;P&gt;$TXT{'241'}&lt;P&gt;&lt;BR&gt;<BR>!;
		if($FORM{'type'} == 5) {
			print qq!
			&lt;SELECT NAME="group1"&gt;<BR>
			!;
		}
		for($i=1;$i < $FORM{'num'};$i++) {
			
			$field = "group$i";
			
			if($FORM{'type'} == 3) {
				print qq!
				&lt;INPUT TYPE="CHECKBOX" NAME="$field" VALUE="$FORM{$field}"&gt; $FORM{$field}&lt;BR&gt;<BR>
				!;
			}
			elsif($FORM{'type'} == 4) {
				print qq!
				&lt;INPUT TYPE="RADIO" NAME="group1" VALUE="$FORM{$field}"&gt; $FORM{$field}&lt;BR&gt;<BR>
				!;
			}
			elsif($FORM{'type'} == 5) {
				print qq!
				&lt;OPTION VALUE="$FORM{$field}"&gt;$FORM{$field}&lt;/OPTION&gt;<BR>
				!;	
			}
			elsif($FORM{'type'} == 6) {
				print qq!
				&lt;INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}"&gt;<BR>
				!;	
			}
			
		}
		
		if($FORM{'type'} == 5) {
			print qq!
			&lt;/SELECT&gt;<BR>
			!;
		}
		
	}
	
	if($FORM{'subscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		&lt;INPUT TYPE="HIDDEN" NAME="subscribe_redirect" <NOBR>VALUE="$FORM{'subscribe_redirect'}"&gt;</NOBR><BR>
		!;
	}
	if($FORM{'unsubscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		&lt;INPUT TYPE="HIDDEN" NAME="unsubscribe_redirect" <NOBR>VALUE="$FORM{'unsubscribe_redirect'}"&gt;</NOBR><BR>
		!;
	}
	if($FORM{'verify_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		&lt;INPUT TYPE="HIDDEN" NAME="verify_redirect" <NOBR>VALUE="$FORM{'verify_redirect'}"&gt;</NOBR><BR>
		!;
	}
	if($FORM{'type'} == 2) {
		print qq!
		&lt;INPUT TYPE="RADIO" NAME="action" VALUE="add" CHECKED="CHECKED"&gt; $TXT{'76'} |<BR>
		&lt;INPUT TYPE="RADIO" NAME="action" VALUE="remove"&gt; $TXT{'77'}&lt;BR&gt;<BR>
		!;
	}
	print qq!
	&lt;P&gt;<BR>
	&lt;INPUT TYPE="SUBMIT" VALUE="Submit"&gt;<BR>
	&lt;/FORM&gt;&lt;P&gt;<BR>
	!;

	
	
	# STOP REPLACING HERE!
	print qq!
	<BR>
	<H3>$TXT{'242'}</H3><P>
	
	<FORM ACTION="$script_directory/manager.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="autoresponder" VALUE="$FORM{'autoresponder'}">
	!;
	
	$FORM{'field_num'} += 1;
	
	@required = ();
	
	for($i=1;$i<=$FORM{'field_num'};$i++) {
		$field = "use$i";
		if($FORM{$field}) {
			print qq!<INPUT TYPE="TEXT" NAME="$FORM{$field}" SIZE=20> $FORM{$field}<BR>\n!;
		}
		$field = "require$i";
		if($FORM{$field}) {
			push(@required,"$FORM{$field}");
		}
	}
	
	$required = join(",",@required);
	print qq!<INPUT TYPE="HIDDEN" NAME="required" VALUE="$required">\n!;
	
	if($FORM{'type'} <= 2) {
		print qq!
		<INPUT TYPE="HIDDEN" NAME="group1" VALUE="$FORM{'group1'}">
		!;
	}
	else {
		print qq!<P>Please choose the mailing list(s) you wish to join<P>!;
		if($FORM{'type'} == 5) {
			print qq!
			<SELECT NAME="group1">
			!;
		}
		
		for($i=1;$i < $FORM{'num'};$i++) {
			
			$field = "group$i";
			
			if($FORM{'type'} == 3) {
				print qq!
				<INPUT TYPE="CHECKBOX" NAME="$field" VALUE="$FORM{$field}"> $FORM{$field}<BR>
				!;
			}
			elsif($FORM{'type'} == 4) {
				print qq!
				<INPUT TYPE="RADIO" NAME="group1" VALUE="$FORM{$field}"> $FORM{$field}<BR>
				!;
			}
			elsif($FORM{'type'} == 5) {
				print qq!
				<OPTION VALUE="$FORM{$field}">$FORM{$field}</OPTION>
				!;	
			}
			elsif($FORM{'type'} == 6) {
				print qq!
				<INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}">
				!;	
			}
			
		}
		
		if($FORM{'type'} == 5) {
			print qq!
			</SELECT>
			!;
		}
		
	}
	
	if($FORM{'subscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		<INPUT TYPE="HIDDEN" NAME="subscribe_redirect" VALUE="$FORM{'subscribe_redirect'}">
		!;
	}
	if($FORM{'unsubscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		<INPUT TYPE="HIDDEN" NAME="unsubscribe_redirect" VALUE="$FORM{'unsubscribe_redirect'}">
		!;
	}
	if($FORM{'verify_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		<INPUT TYPE="HIDDEN" NAME="verify_redirect" VALUE="$FORM{'verify_redirect'}">
		!;
	}
	if($FORM{'type'} == 2) {
		print qq!
		<INPUT TYPE="RADIO" NAME="action" VALUE="add" CHECKED="CHECKED"> Subscribe |
		<INPUT TYPE="RADIO" NAME="action" VALUE="remove"> Unsubscribe<BR>
		!;
	}
	print qq!
	<P>
	<INPUT TYPE="SUBMIT" VALUE="Submit">
	</FORM><P>
	!;
		
	
	# PRINT THE UNSUBSCRIBE FORM SOURCE
	
	if($FORM{'type'} != 2) {
	print qq!
	<BR>
	<H3>$TXT{'290'}</H3>
	$TXT{'291'}<P>
	
	&lt;FORM ACTION="$script_directory/manager.pl" METHOD="POST"&gt;<BR>
	&lt;INPUT TYPE="HIDDEN" NAME="autoresponder" VALUE="$FORM{'autoresponder'}"&gt;<BR>
	&lt;INPUT TYPE="HIDDEN" NAME="action" VALUE="remove"&gt;<BR>
	&lt;INPUT TYPE="TEXT" NAME="email" SIZE=25&gt; Email&lt;BR&gt;<BR>
	!;
	
	for($i=1;$i < $FORM{'num'};$i++) {
		$field = "group$i";
		print qq!&lt;INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}"&gt;<BR>!;
	}
	
	if($FORM{'unsubscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		&lt;INPUT TYPE="HIDDEN" NAME="unsubscribe_redirect" <NOBR>VALUE="$FORM{'unsubscribe_redirect'}"&gt;</NOBR><BR>
		!;
	}
	
	print qq!
	&lt;INPUT TYPE="SUBMIT" VALUE="$TXT{'77'}"&gt;<BR>
	&lt;/FORM&gt;<P>
	!;
	
	## PRINT THE UNSUBSCRIBE FORM
	
	print qq!
	<BR>
	<H3>$TXT{'292'}</H3>
	
	<FORM ACTION="$script_directory/manager.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="remove">
	<INPUT TYPE="HIDDEN" NAME="autoresponder" VALUE="$FORM{'autoresponder'}">
	<INPUT TYPE="TEXT" NAME="email" SIZE=25> Email<BR>
	!;
	
	for($i=1;$i < $FORM{'num'};$i++) {
		$field = "group$i";
		print qq!<INPUT TYPE="HIDDEN" NAME="$field" VALUE="$FORM{$field}">!;
	}
	
	if($FORM{'unsubscribe_redirect'} =~ /(.+):\/\/.+\..+/) {
		print qq!
		<INPUT TYPE="HIDDEN" NAME="unsubscribe_redirect" VALUE="$FORM{'unsubscribe_redirect'}"><BR>
		!;
	}
	
	print qq!
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'77'}">
	</FORM><P>
	!;
	}
	&admin_footer;	
}

else {
	&admin_error("$TXT{'4'}");
}