#! /usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on January 25, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#

BEGIN {
if($0 !~ /^import\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'library.pl';
require 'config.pl';
require "$language.lib";
use CGI;

$mydata = new CGI; 
$FORM{'action'} = $mydata->param("action");
$FORM{'name'} = $mydata->param("name");
$FORM{'new'} = $mydata->param("new");
$FORM{'new_name'} = $mydata->param("new_name");
$FORM{'delimiter'} = $mydata->param("delimiter");
$FORM{'quote'} = $mydata->param("quote");
$FORM{'username'} = $mydata->param("username");
$FORM{'password'} = $mydata->param("password");
&check_pass;

if($FORM{'action'} eq "") {
	
	unless($FORM{'delimiter'} && ($FORM{'name'} || ($FORM{'new'} && $FORM{'new_name'}))) {
		&admin_error("$TXT{'278'}");
	}

	if($FORM{'new'}) {
		$FORM{'name'} = $FORM{'new_name'};
	}
	
	#$myfile = "";
	#$file = $mydata->param("file"); 
	
	open(TEMP,">$base_dir/$FORM{'name'}.import") || &error("$TXT{'1'} $FORM{'name'}.import");
	
	while($bytes = read($mydata->param("file"),$buff,1024)) {
		
		$bytes_read += $bytes;
		$buff =~ s/\r/\n/gs;
		$buff =~ s/\n\n/\n/gs;
		print TEMP $buff;
	}
	
	#$myfile =~ s/\r/\n/gs;
	#$myfile =~ s/\n\n/\n/gs;
	#print TEMP "$myfile";
	close(TEMP);
	
	&admin_header;
	
	print qq!
	<H2>$TXT{'281'}</H2>
	
	$TXT{'279'}<P>
	<FORM ACTION="import.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="import">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<INPUT TYPE="HIDDEN" NAME="new_name" VALUE="$FORM{'new_name'}">
	<INPUT TYPE="HIDDEN" NAME="new" VALUE="$FORM{'new'}">
	<INPUT TYPE="HIDDEN" NAME="quote" VALUE="$FORM{'quote'}">
	<INPUT TYPE="HIDDEN" NAME="delimiter" VALUE="$FORM{'delimiter'}">
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'280'}">
	!;
	
	if(-e "$base_dir/$FORM{'name'}.info") {
		open(MYFIELDS,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
		@data =<MYFIELDS>;
		close(MYFIELDS);
		@myfields = split(/\&\&/,$data[1]);
	}
	
	print "<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=2 BGCOLOR=\"FFFFFF\">\n";
	print "<TR BGCOLOR=\"FFDDDD\">\n";
	
	$i = 0;
	open(IMPORT,"$base_dir/$FORM{'name'}.import") || &error("$TXT{'2'} $FORM{'name'}.import");
	while($line =<IMPORT>) {
		if($i > 50) {
			last;
		}
		
		chomp($line);
		$line =~ s/\r$//g;
		
		@fields = split(/$FORM{'delimiter'}/,$line);
		if($i < 1) {
			$x = 1;
			foreach $field (@fields) {
				if(@myfields) {
					print "<TD><SELECT NAME=\"field$x\">\n";
					print "<OPTION VALUE=\"\">None</OPTION>\n";
					foreach $myfield (@myfields) {
						print "<OPTION>$myfield</OPTION>\n";
					}
					print "</SELECT></TD>\n";
				}
				else {
					print "<TD><FONT SIZE=2 FACE=\"Arial\"><INPUT TYPE=\"TEXT\" SIZE=15 NAME=\"field$x\"></FONT></TD>\n";
				}
				
				$x++;
			}
			print "</TR></FORM>\n";
		}
			
		print "<TR BGCOLOR=\"DDDDDD\">\n";
		foreach $field (@fields) {
			if($FORM{'quote'} eq "single") {
				$field =~ s/\'//g;
			}
			elsif($FORM{'quote'} eq "double") {
				$field =~ s/\"//g;
			}
			print "    <TD>$field</TD>\n";
		}
		print "</TR>\n";
		
		$i++;
	}
	close(IMPORT);
	
	print qq!
	</TABLE>
	$TXT{'75'}
	!;
	&admin_footer;
}

if($FORM{'action'} eq "import") {
	
	$y = 0;
	
	if($FORM{'new'}) {
		$FORM{'name'} = $FORM{'new_name'};
	}
	
	&file_lock("$FORM{'name'}");
	
	open(IMPORT,"$base_dir/$FORM{'name'}.import") || &admin_error("$TXT{'2'} $FORM{'name'}.import");
	
	if(! $FORM{'new'}) {
		open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
		@MYINFO =<INFO>;
		close(INFO);	
		@original_fields = split(/\&\&/,$MYINFO[1]);	
	}
	
	open(LIST,">$base_dir/$FORM{'name'}.dat.tmp") || &admin_error("$TXT{'1'} $FORM{'name'}.dat");
		
	# Define @original_fields if not already defined.
			
	while($line =<IMPORT>) {	
		chomp($line);
		
		if($line eq "") {
			next;
		}
		
		$line =~ s/\r$//;
		@fields = split(/$FORM{'delimiter'}/,$line);
		
		if($y < 1 && $FORM{'new'}) {
			
			@original_fields = ();
			
			$x = 1;
			foreach $field (@fields) {
				$field = "field$x";
				if($mydata->param("$field")) {
					push(@original_fields,$mydata->param("$field"));
				}
				else {
					push(@original_fields,"XXXXXXXXXX");
				}
				$x += 1;
			}
		}
		
		$entry = "";

		foreach $ofield (@original_fields) {
			$i = 1;
			$f = 0;
			foreach $field (@fields) {
				
				$field_name = "field$i";
				
				if($FORM{'quote'} eq "single") {
					$field =~ s/^\'//g;
					$field =~ s/\'$//g;
				}
				elsif($FORM{'quote'} eq "double") {
					$field =~ s/^\"//g;
					$field =~ s/\"$//g;
				}
				
				if($ofield eq $mydata->param("$field_name")) {
					$f = 1;
					$entry .= "$field&&";
					if($y < 1) {
						push(@MYFIELDS,"$ofield");
					}
					
					last;
				}
				
				$i++;
			}
			if(! $FORM{'new'} && ! $f) {
				$entry .= "&&";
			}
		}
		
		chop($entry);
		chop($entry);
		print LIST "$entry\n";
		$y += 1;
	}
	close(IMPORT);
	close(LIST);
	
	$ok = 0;
	foreach $field (@MYFIELDS) {
		if($field eq "email") {
			$ok = 1;
			last;
		}
	}
	
	if(! $ok) {
		unlink("$base_dir/$FORM{'name'}.dat.tmp") || &admin_error("$TXT{'282'} $FORM{'name'}.dat.tmp");
		&admin_error("$TXT{'288'}");
	}
	
	if(! $FORM{'new'}) {
		open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
		chomp($c = <INFO>);
		close(INFO);
	
		$y += $c;
		
		open(DAT,"$base_dir/$FORM{'name'}.dat.tmp") || &admin_error("$TXT{'2'} $FORM{'name'}.dat.tmp");
		open(NEWDAT,">>$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'1'} $FORM{'name'}.dat");
		while($line =<DAT>) {
			print NEWDAT "$line";
		}
		close(NEWDAT);
		close(DAT);
		
		unlink("$base_dir/$FORM{'name'}.dat.tmp") || &admin_error("$TXT{'282'} $FORM{'name'}.dat.tmp");
	}
	else {
		rename("$base_dir/$FORM{'name'}.dat.tmp","$base_dir/$FORM{'name'}.dat") || &admin_error("$TXT{'283'} $FORM{'name'}.dat.tmp");
	}
	
	open(INFO,">$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'1'}$FORM{'name'}.info");
	print INFO "$y\n";
	$fields = join("&&",@original_fields);
	print INFO "$fields";
	close(INFO);
	
	unlink("$base_dir/$FORM{'name'}.import") || &admin_error("$TXT{'283'} $FORM{'name'}.import");;
	
	&file_unlock("$FORM{'name'}");
	
	$y -= $c;
	
	$TXT{'285'} =~ s/<<num_entries>>/$y/g;
	
	&admin_header;
	print qq!
	<H2>$TXT{'284'}</H2>
	
	$TXT{'285'}
	
	$TXT{'75'}
	!;
	&admin_footer;
}