#!/usr/bin/perl

# Post Office Pro 4.0
# Copyright  2000-2001 CGI Paradise
# Released on April 2, 2001
# 
# Please refer to the documentation for licensing information.
# Distributing or selling this software is strictly prohibited.
#


BEGIN {
if($0 !~ /^optout\.(cgi|pl)$/i && $0) {
	$this_dir = $0;
}
elsif($ENV{'SCRIPT_FILENAME'} && $ENV{'SCRIPT_FILENAME'} !~ /cgiwrap/) {
	$this_dir = $ENV{'SCRIPT_FILENAME'};
}
elsif($ENV{'PATH_TRANSLATED'}) {
	$this_dir = $ENV{'PATH_TRANSLATED'};
}
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");
}

require 'config.pl';
require 'library.pl';
require "$language.lib";

&parse_form;
&check_pass;



open(INFO,"$base_dir/$FORM{'name'}.info") || &admin_error("$TXT{'2'} $FORM{'name'}.info");
@MYINFO =<INFO>;
close(INFO);

@fields = split(/\&\&/,$MYINFO[1]);

if($FORM{'action'} eq "") {
	
	&admin_header;
	print qq!
	<H3>$TXT{'303'}</H3>
	$TXT{'304'}<P>
	<FORM ACTION="optout.pl" METHOD="GET">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="search">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	$TXT{'305'}:<BR>
	<INPUT TYPE="TEXT" NAME="email" SIZE=30>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'251'}">
	</FORM><P>
	
	<H3>$TXT{'307'}</H3>
	$TXT{'308'}<P>
	<FORM ACTION="optout.pl" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="add">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
Example:<BR>
email1\@mydomain.com<BR>
email2\@mydomain.com<BR>
email3\@mydomain.com<BR>
email4\@mydomain.com<P>
	<TEXTAREA COLS=40 ROWS=12 NAME="addresses" WRAP="off"></TEXTAREA><BR>
	<INPUT TYPE="SUBMIT" VALUE="$TXT{'307'}">
	</FORM>
	!;
	print "$TXT{'75'}\n";
	&admin_footer;
}

elsif($FORM{'action'} eq "search") {
	if(! -e "$base_dir/$FORM{'name'}.out") {
		&admin_error("$TXT{'302'}");
	}
	&admin_header;
	print qq!
	<SCRIPT LANGUAGE="Javascript">
	<\!-------
	
	function CheckAll() {
		for(var i = 0;i < document.dform.elements.length;i++) {
			document.dform.elements[i].checked = true;
		}
	}
	
	function UncheckAll() {
		for(var i = 0;i < document.dform.elements.length;i++) {
			document.dform.elements[i].checked = false;
		}
	}
	------->
	</SCRIPT>
	
	<H3>$TXT{'306'}</H3>
	<TABLE BORDER=0 CELLSPACING=2 CELLPADDING=4>
	<FORM ACTION="optout.pl" METHOD="POST" NAME="dform">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="delete">
	<INPUT TYPE="HIDDEN" NAME="name" VALUE="$FORM{'name'}">
	<TR BGCOLOR="FFDDDD"><TD>#</TD><TD><B>email</B></TD><TD><B>Delete?</B></TD></TR>
	!;
	
	$i = 0;
	
	open(OUT,"$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'2'} $FORM{'name'}.out");
	while($line =<OUT>) {
		if($line =~ /$FORM{'email'}/i) {
			$i++;
			chomp($line);
			print qq!
			<TR BGCOLOR=\"DDDDDD\"><TD>$i</TD><TD>$line</TD><TD ALIGN="CENTER"><INPUT TYPE="CHECKBOX" NAME="$line" VALUE="1"></TD></TR>
			!;
		}
	}
	close(OUT);
	print qq!
	<TR><TD>
	<INPUT TYPE="SUBMIT" VALUE="Delete Email Addresses">
	</TD><TD>
	<A HREF="javascript: CheckAll()">$TXT{'257'}</A><BR>
	<A HREF="javascript: UncheckAll()">$TXT{'258'}</A>
	</TD>
	</TR>
	</FORM>
	</TABLE>
	!;
	print "<P><A HREF=\"optout.pl?name=$FORM{'name'}\">$TXT{'311'}</A><BR>\n";
	print "$TXT{'75'}\n";
	&admin_footer;
}
elsif($FORM{'action'} eq "add") {
	
	$added = 0;
	@entries = split(/\s+/,$FORM{'addresses'});
	if(! -e "$base_dir/$FORM{'name'}.out") {
		open(OUT,">$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'1'} $FORM{'name'}.out");
		print OUT "";
		close(OUT);
	}
	open(OUT,">>$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'1'} $FORM{'name'}.out");
	foreach $entry (@entries) {
		if(&checksyntax($entry)) {
			print OUT "$entry\n";
			$added++;
		}
	}
	close(OUT);
	
	&admin_header;
	print qq!
	<H3>$TXT{'313'}</H3>
	$added $TXT{'314'}
	!;
	print "<P><A HREF=\"optout.pl?name=$FORM{'name'}\">$TXT{'311'}</A><BR>\n";
	print "$TXT{'75'}\n";
	&admin_footer;
	
}
elsif($FORM{'action'} eq "delete") {
	
	if(! -e "$base_dir/$FORM{'name'}.out") {
		&admin_error("$TXT{'302'}");
	}
	$deleted = 0;
	&file_lock("$FORM{'name'}");
	open(OUT,"$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'2'} $FORM{'name'}.out");
	open(TMP,">$base_dir/$FORM{'name'}.otmp") || &admin_error("$TXT{'1'} $FORM{'name'}.otmp");
	MAIN: while($line = <OUT>) {
		chomp($line);
		foreach $key (keys %FORM) {
			if($key ne "action" && $key ne "name") {
				if($key eq "$line" && $FORM{$key}) {
					$deleted++;
					next MAIN;
				}
			}
		}
		print TMP "$line\n";	
	}
	close(OUT);
	close(TMP);
	unlink("$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'1'} $FORM{'name'}.out");
	rename("$base_dir/$FORM{'name'}.otmp","$base_dir/$FORM{'name'}.out") || &admin_error("$TXT{'1'} $FORM{'name'}.out");
	&file_unlock("$FORM{'name'}");
	
	&admin_header;
	print qq!
	<H3>$TXT{'310'}</H3>
	$deleted $TXT{'312'}
	!;
	print "<P><A HREF=\"optout.pl?name=$FORM{'name'}\">$TXT{'311'}</A><BR>\n";
	print "$TXT{'75'}\n";
	&admin_footer;
}
else {
	&admin_error("$TXT{'4'}");
}